import * as i0 from '@angular/core';
import { Pipe, Component, ViewEncapsulation, Input, NgModule, Injectable, EventEmitter, Directive, Output, HostBinding, HostListener, forwardRef, Self, Inject, NgZone, ErrorHandler, Optional, SkipSelf } from '@angular/core';
import * as i1 from 'monkey-style-guide';
import { MonkeyButtonModule, MonkeyIconModule, MonkeyInputModule, MonkeyModalModule, MonkeyUtils, MonkeyStyleGuideModule, MonkeyStyleGuideModalService, MonkeyStyleGuideSettingsService, MonkeyStyleGuideSnackbarService } from 'monkey-style-guide';
import * as i1$1 from '@ngx-translate/core';
import { TranslateService, TranslateModule } from '@ngx-translate/core';
import * as moment_ from 'moment';
import * as i1$2 from '@angular/common';
import { formatNumber, CommonModule, CurrencyPipe, DOCUMENT, registerLocaleData } from '@angular/common';
import * as i1$3 from '@angular/router';
import { NavigationStart, NavigationEnd, NavigationError, NavigationCancel } from '@angular/router';
import { BehaviorSubject, throwError, interval, concat, of } from 'rxjs';
import { filter, take, takeWhile, map, catchError, first, mergeMap, finalize } from 'rxjs/operators';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
import { __decorate } from 'tslib';
import * as i1$4 from '@angular/common/http';
import { HttpParams, HttpErrorResponse, HTTP_INTERCEPTORS, HttpClientModule } from '@angular/common/http';
import localePTBR from '@angular/common/locales/global/pt';
import { datadogRum } from '@datadog/browser-rum';
import * as i1$5 from '@angular/service-worker';
import { ServiceWorkerModule } from '@angular/service-worker';
import { initialize } from 'launchdarkly-js-client-sdk';

/* eslint-disable comma-dangle */
/* eslint-disable max-len */
/* eslint-disable no-useless-escape */
/* eslint-disable no-plusplus */
/* eslint-disable no-cond-assign */
/* eslint-disable eqeqeq */
/* eslint-disable no-redeclare */
/* eslint-disable vars-on-top */
/* eslint-disable no-var */
/* eslint-disable block-scoped-var */
class MonkeyExcUtils {
    static persistNullEmptyUndefined(tp) {
        return tp !== null && tp !== undefined && tp !== '';
    }
    static getDocumentType(doc) {
        if (!doc)
            return '';
        return doc.length <= 11 ? 'CPF' : 'CNPJ';
    }
    static getDocumentMask(type) {
        if (type === 'CPF')
            return '000.000.000-00';
        return '00.000.000/0000-00';
    }
    static formatDocumentWithMask(doc, withType) {
        if (!doc)
            return doc;
        let formated = '';
        if (doc.length === 14) {
            formated = doc
                .replace(/^(\d{2})(\d)/, '$1.$2')
                .replace(/^(\d{2})\.(\d{3})(\d)/, '$1.$2.$3')
                .replace(/\.(\d{3})(\d)/, '.$1/$2')
                .replace(/(\d{4})(\d)/, '$1-$2');
        }
        else {
            formated = doc
                .replace(/^(\d{3})(\d)/, '$1.$2')
                .replace(/^(\d{3})\.(\d{3})(\d)/, '$1.$2.$3')
                .replace(/\.(\d{3})(\d)/, '.$1-$2');
        }
        return `${withType ? `${this.getDocumentType(doc)}:` : ''} ${formated}`;
    }
    static cutFirstLastName(value, tp = 'first') {
        var _a, _b;
        const split = (_a = value === null || value === void 0 ? void 0 : value.trim()) === null || _a === void 0 ? void 0 : _a.split(' ');
        if (tp === 'first')
            return split[0];
        return (_b = split === null || split === void 0 ? void 0 : split.splice(1, split.length)) === null || _b === void 0 ? void 0 : _b.join(' ');
    }
    static isCPFCNPJValid(document) {
        document = document.replace(/[^\d]/g, '');
        if (document.length === 11) {
            let base = [10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0];
            for (var i = 0, n = 0; i < 9; n += document[i] * base[i++])
                ;
            if (document[9] != ((n %= 11) <= 1 ? 0 : 11 - n)) {
                return false;
            }
            base = [11, 10, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0];
            for (var i = 0, n = 0; i <= 9; n += document[i] * base[i++])
                ;
            if (document[10] != ((n %= 11) <= 1 ? 0 : 11 - n)) {
                return false;
            }
            return true;
        }
        if (document.length === 14 || /0{14}/.test(document)) {
            const base = [6, 5, 4, 3, 2, 9, 8, 7, 6, 5, 4, 3, 2];
            for (var i = 0, n = 0; i < 12; n += document[i] * base[++i])
                ;
            if (document[12] != ((n %= 11) < 2 ? 0 : 11 - n)) {
                return false;
            }
            for (var i = 0, n = 0; i <= 12; n += document[i] * base[i++])
                ;
            if (document[13] != ((n %= 11) < 2 ? 0 : 11 - n)) {
                return false;
            }
            return true;
        }
        return false;
    }
    static isValidUrl(txt) {
        const regex = new RegExp(/^(http:\/\/www\.|https:\/\/www\.|http:\/\/|https:\/\/)+[a-z0-9]+([\-\.]{1}[a-z0-9]+)*\.[a-z]{2,10}(:[0-9]{1,5})?(\/.*)?$/gm);
        return regex.test(txt);
    }
    static isValidZipCode(zipCode) {
        return `${this.handleOnlyNumbers(zipCode)}`.length === 8;
    }
    static getRandomString(len, charSet) {
        charSet = charSet || 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
        const randomString = new Array(len)
            .fill('1')
            .map(() => {
            return charSet.charAt(Math.floor(Math.random() * charSet.length));
        })
            .join('');
        return randomString;
    }
    static handleOnlyNumbers(value) {
        if (!value)
            return null;
        return value.replace(new RegExp(/[^0-9]/g), '');
    }
    static handleOnlyAlphaNumeric(value) {
        if (!value)
            return '';
        return value.replace(new RegExp(/[^0-9A-Za-z]/, 'g'), '');
    }
    static capitalize(value) {
        return `${value.charAt(0).toUpperCase()}${value.slice(1)}`;
    }
    static formatZipCode(zipCode) {
        if (!zipCode)
            return zipCode;
        const formated = zipCode
            .replace(/^(\d{5})(\d)/, '$1-$2')
            .replace(/\.(\d{3})(\d)/, '.$1-$2');
        return `${formated}`;
    }
    static formatFileSize(size) {
        const units = ['B', 'KB', 'MB', 'GB', 'TB', 'PB', 'EB', 'ZB', 'YB'];
        let l = 0;
        while (size >= 1024 && ++l) {
            size /= 1024;
        }
        return `${size.toFixed(size < 10 && l > 0 ? 1 : 0)} ${units[l]}`;
    }
    static sufflue(data) {
        for (let i = data.length - 1; i > 0; i--) {
            const j = Math.floor(Math.random() * i);
            const temp = data[i];
            data[i] = data[j];
            data[j] = temp;
        }
        return data;
    }
    static handleBlobFile(theBlob, fileName, fileType) {
        function blobToFile(theBlob, fileName) {
            const b = theBlob;
            b.lastModifiedDate = new Date();
            b.name = fileName;
            return b;
        }
        let file;
        if (!navigator.msSaveBlob) {
            file = new File([theBlob], fileName, {
                type: fileType,
            });
        }
        else {
            file = new Blob([theBlob], {
                type: fileType,
            });
            file = blobToFile(file, fileName);
        }
        return file;
    }
    static truncate(text, maxLength = 25) {
        const midChar = '...';
        if (!text)
            return midChar;
        if (text && text.length <= maxLength)
            return text;
        const left = Math.ceil(maxLength / 2);
        const right = text.length - left + 1;
        return `${text.substr(0, left)} ${midChar} ${text.substring(right)}`;
    }
    static isLocalhost() {
        const { href } = window === null || window === void 0 ? void 0 : window.location;
        if (!href)
            return false;
        return (href === null || href === void 0 ? void 0 : href.search('localhost')) >= 0;
    }
    static isSameOrigin(frontend) {
        const initialPath = window.location.origin;
        return (initialPath || '') === frontend;
    }
}

const moment$1 = moment_;
class MonkeyExcFormatDateTimelapsePipe {
    constructor() {
        // not todo
    }
    transform(date, showTime = false, useUtc = true, format) {
        var _a;
        if (!MonkeyExcUtils.persistNullEmptyUndefined(date))
            return '';
        if (!format) {
            format = '- HH:mm';
        }
        let stillUtc = moment$1.utc(date).toDate();
        if (!useUtc)
            stillUtc = moment$1(date).toDate();
        if (((_a = date.toString()) === null || _a === void 0 ? void 0 : _a.indexOf(':')) <= -1) {
            stillUtc = date;
            showTime = false;
        }
        const formatFrom = `YYYY/MM/DD${showTime ? ` ${format}` : ''}`;
        const formatTo = `DD/MM/YYYY${showTime ? ` ${format}` : ''}`;
        return `${moment$1(stillUtc, formatFrom).format(formatTo)}`;
    }
}
MonkeyExcFormatDateTimelapsePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatDateTimelapsePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
MonkeyExcFormatDateTimelapsePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatDateTimelapsePipe, name: "monkeyexcFormatDateTimelapse" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatDateTimelapsePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monkeyexcFormatDateTimelapse',
                }]
        }], ctorParameters: function () { return []; } });

class ClosedToMaintenanceComponent {
    constructor() {
        this._configBoostrap = null;
    }
    ngOnInit() {
        this._configBoostrap = this.config.data;
    }
    onClose() {
        document.location.reload();
    }
}
ClosedToMaintenanceComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ClosedToMaintenanceComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
ClosedToMaintenanceComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.0.5", type: ClosedToMaintenanceComponent, selector: "monkeyexc-closed-to-maintenance", inputs: { config: "config", modalRef: "modalRef" }, ngImport: i0, template: "<monkey-modal [config]=\"config\" [modalRef]=\"modalRef\">\n  <div class=\"d-flex flex-column justify-content-center align-items-center\">\n    <span class=\"h2\">\n      {{ 'SCREENS.CLOSED-TO-MAINTENANCE.TITLE' | translate }}\n    </span>\n    <span class=\"information-title mt-4\">\n      {{ 'SCREENS.CLOSED-TO-MAINTENANCE.INFORMATION-1' | translate }}\n    </span>\n    <span class=\"information-title mt-4\">\n      {{ 'SCREENS.CLOSED-TO-MAINTENANCE.INFORMATION-2' | translate }}\n    </span>\n    <span class=\"information mt-3\">\n      {{ 'SCREENS.CLOSED-TO-MAINTENANCE.INFORMATION-3' | translate }}\n      {{ _configBoostrap?.maintenance?.endDate | monkeyexcFormatDateTimelapse: true }}\n    </span>\n    <span class=\"information-title mt-4\">\n      {{ 'SCREENS.CLOSED-TO-MAINTENANCE.INFORMATION-4' | translate }}\n    </span>\n  </div>\n  <div class=\"d-flex flex-column justify-content-center align-items-center mt-5\">\n    <monkey-button type=\"primary\" color=\"theme\" (click)=\"onClose()\">\n      {{ 'SCREENS.CLOSED-TO-MAINTENANCE.BUTTONS.UPDATE-MAINTENANCE' | translate }}\n    </monkey-button>\n  </div>\n</monkey-modal>", styles: ["monkeyexc-closed-to-maintenance .body{padding:24px;width:100%}monkeyexc-closed-to-maintenance .information-title{font-style:normal;font-weight:600;font-size:25px;line-height:32px;display:flex;align-items:center;text-align:center;color:#4b4a53}monkeyexc-closed-to-maintenance .information{font-style:normal;font-weight:400;font-size:20px;line-height:24px;display:flex;align-items:center;text-align:center;color:#4b4a53;max-width:600px}monkeyexc-closed-to-maintenance .browser-name{font-style:normal;font-weight:400;font-size:16px;line-height:24px;text-align:center;color:#9c9ca6}monkeyexc-closed-to-maintenance .option{text-decoration:none;padding:4px;background:#eee;border:1px solid #d6d6d6;box-sizing:border-box;border-radius:16px}monkeyexc-closed-to-maintenance monkey-modal mecx-monkey-modal .body{margin-bottom:0!important}"], components: [{ type: i1.MonkeyModalComponent, selector: "monkey-modal", inputs: ["onHandleConfirm", "config", "modalRef"] }, { type: i1.MonkeyButtonComponent, selector: "monkey-button", inputs: ["iconPosition", "disabled", "label", "icon", "type", "color"] }], pipes: { "translate": i1$1.TranslatePipe, "monkeyexcFormatDateTimelapse": MonkeyExcFormatDateTimelapsePipe }, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ClosedToMaintenanceComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'monkeyexc-closed-to-maintenance',
                    templateUrl: './closed-to-maintenance.component.html',
                    styleUrls: ['./closed-to-maintenance.component.scss'],
                    encapsulation: ViewEncapsulation.None
                }]
        }], propDecorators: { config: [{
                type: Input
            }], modalRef: [{
                type: Input
            }] } });

class MonkeyExcFormatNumber {
    constructor() {
        // not to do
    }
    transform(number) {
        if (!MonkeyExcUtils.persistNullEmptyUndefined(number))
            return '';
        return formatNumber(Number(number), 'ptbr');
    }
}
MonkeyExcFormatNumber.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatNumber, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
MonkeyExcFormatNumber.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatNumber, name: "monkeyexcFormatNumber" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatNumber, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monkeyexcFormatNumber'
                }]
        }], ctorParameters: function () { return []; } });

class MonkeyExcFormatValue {
    constructor() {
        // not to do
    }
    transform(number) {
        if (!MonkeyExcUtils.persistNullEmptyUndefined(number))
            return '';
        return number;
    }
}
MonkeyExcFormatValue.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatValue, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
MonkeyExcFormatValue.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatValue, name: "monkeyexcFormatValue" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatValue, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monkeyexcFormatValue'
                }]
        }], ctorParameters: function () { return []; } });

class MonkeyExcFormatDocumentPipe {
    constructor() {
        // not to do
    }
    transform(document, withType) {
        if (!MonkeyExcUtils.persistNullEmptyUndefined(document))
            return '';
        return MonkeyExcUtils.formatDocumentWithMask(document, withType);
    }
}
MonkeyExcFormatDocumentPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatDocumentPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
MonkeyExcFormatDocumentPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatDocumentPipe, name: "monkeyexcFormatDocument" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatDocumentPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monkeyexcFormatDocument'
                }]
        }], ctorParameters: function () { return []; } });

class MonkeyExcDisplayFirstNamePipe {
    constructor() {
        // not to do
    }
    transform(name) {
        if (!MonkeyExcUtils.persistNullEmptyUndefined(name))
            return '';
        return MonkeyExcUtils.cutFirstLastName(name);
    }
}
MonkeyExcDisplayFirstNamePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDisplayFirstNamePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
MonkeyExcDisplayFirstNamePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDisplayFirstNamePipe, name: "monkeyexcDisplayFirstName" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDisplayFirstNamePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monkeyexcDisplayFirstName'
                }]
        }], ctorParameters: function () { return []; } });

class MonkeyExcFormatSizePipe {
    constructor() {
        // not to do
    }
    transform(size) {
        if (!size)
            return '0 B';
        const sizeNum = Number(size);
        return MonkeyExcUtils.formatFileSize(sizeNum);
    }
}
MonkeyExcFormatSizePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatSizePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
MonkeyExcFormatSizePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatSizePipe, name: "monkeyexcFormatSize" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatSizePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monkeyexcFormatSize'
                }]
        }], ctorParameters: function () { return []; } });

class MonkeyExcFormatCurrencyPipe {
    constructor(injector, currencyPipe) {
        this.injector = injector;
        this.currencyPipe = currencyPipe;
        this.currencyCode = 'BRL';
        this.currentLocale = 'pt-BR';
        const translateService = this.injector.get(TranslateService);
        translateService.get('MONKEY-CURRENCY-CODE').subscribe((_) => {
            this.currencyCode = _;
            this.currentLocale = translateService.getDefaultLang();
        });
    }
    transform(value) {
        const { currencyCode, currentLocale } = this;
        return this.currencyPipe.transform(value, currencyCode, 'symbol', '', currentLocale);
    }
}
MonkeyExcFormatCurrencyPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatCurrencyPipe, deps: [{ token: i0.Injector }, { token: i1$2.CurrencyPipe }], target: i0.ɵɵFactoryTarget.Pipe });
MonkeyExcFormatCurrencyPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatCurrencyPipe, name: "monkeyexcFormatCurrency" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatCurrencyPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monkeyexcFormatCurrency'
                }]
        }], ctorParameters: function () { return [{ type: i0.Injector }, { type: i1$2.CurrencyPipe }]; } });

class MonkeyExcFormatZipCodePipe {
    constructor() {
        // not to do
    }
    transform(zipCode) {
        if (!MonkeyExcUtils.persistNullEmptyUndefined(zipCode))
            return '';
        return MonkeyExcUtils.formatZipCode(zipCode);
    }
}
MonkeyExcFormatZipCodePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatZipCodePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
MonkeyExcFormatZipCodePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatZipCodePipe, name: "monkeyexcFormatZipCode" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatZipCodePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monkeyexcFormatZipCode'
                }]
        }], ctorParameters: function () { return []; } });

class MonkeyExcTextTruncatePipe {
    constructor() {
        // not to do
    }
    transform(text, maxLength = 25) {
        const midChar = '...';
        if (!text)
            return midChar;
        if (text && text.length <= maxLength)
            return text;
        const left = Math.ceil(maxLength / 2);
        const right = text.length - left + 1;
        return `${text.substr(0, left)} ${midChar} ${text.substring(right)}`;
    }
}
MonkeyExcTextTruncatePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcTextTruncatePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
MonkeyExcTextTruncatePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcTextTruncatePipe, name: "monkeyexcTextTruncate" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcTextTruncatePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monkeyexcTextTruncate'
                }]
        }], ctorParameters: function () { return []; } });

class MonkeyExcDocumentTypePipe {
    constructor() {
        // not to do
    }
    transform(document) {
        if (!MonkeyExcUtils.persistNullEmptyUndefined(document))
            return '';
        return MonkeyExcUtils.getDocumentType(document);
    }
}
MonkeyExcDocumentTypePipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDocumentTypePipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
MonkeyExcDocumentTypePipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDocumentTypePipe, name: "monkeyexcDocumentType" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDocumentTypePipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monkeyexcDocumentType'
                }]
        }], ctorParameters: function () { return []; } });

class MonkeyExcTruncateQtdPipe {
    transform(number, threshold) {
        return `${number > threshold ? `${threshold}+` : number}`;
    }
}
MonkeyExcTruncateQtdPipe.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcTruncateQtdPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe });
MonkeyExcTruncateQtdPipe.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcTruncateQtdPipe, name: "monkeyexcTruncateQtd" });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcTruncateQtdPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'monkeyexcTruncateQtd'
                }]
        }] });

class MonkeyExcPipesModule {
}
MonkeyExcPipesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcPipesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MonkeyExcPipesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcPipesModule, declarations: [MonkeyExcFormatDocumentPipe,
        MonkeyExcFormatDateTimelapsePipe,
        MonkeyExcDisplayFirstNamePipe,
        MonkeyExcFormatSizePipe,
        MonkeyExcFormatCurrencyPipe,
        MonkeyExcFormatZipCodePipe,
        MonkeyExcFormatNumber,
        MonkeyExcFormatValue,
        MonkeyExcTextTruncatePipe,
        MonkeyExcTruncateQtdPipe,
        MonkeyExcDocumentTypePipe], exports: [MonkeyExcFormatDocumentPipe,
        MonkeyExcFormatDateTimelapsePipe,
        MonkeyExcDisplayFirstNamePipe,
        MonkeyExcFormatSizePipe,
        MonkeyExcFormatCurrencyPipe,
        MonkeyExcFormatZipCodePipe,
        MonkeyExcFormatNumber,
        MonkeyExcFormatValue,
        MonkeyExcTextTruncatePipe,
        MonkeyExcTruncateQtdPipe,
        MonkeyExcDocumentTypePipe] });
MonkeyExcPipesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcPipesModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcPipesModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        MonkeyExcFormatDocumentPipe,
                        MonkeyExcFormatDateTimelapsePipe,
                        MonkeyExcDisplayFirstNamePipe,
                        MonkeyExcFormatSizePipe,
                        MonkeyExcFormatCurrencyPipe,
                        MonkeyExcFormatZipCodePipe,
                        MonkeyExcFormatNumber,
                        MonkeyExcFormatValue,
                        MonkeyExcTextTruncatePipe,
                        MonkeyExcTruncateQtdPipe,
                        MonkeyExcDocumentTypePipe
                    ],
                    exports: [
                        MonkeyExcFormatDocumentPipe,
                        MonkeyExcFormatDateTimelapsePipe,
                        MonkeyExcDisplayFirstNamePipe,
                        MonkeyExcFormatSizePipe,
                        MonkeyExcFormatCurrencyPipe,
                        MonkeyExcFormatZipCodePipe,
                        MonkeyExcFormatNumber,
                        MonkeyExcFormatValue,
                        MonkeyExcTextTruncatePipe,
                        MonkeyExcTruncateQtdPipe,
                        MonkeyExcDocumentTypePipe
                    ]
                }]
        }] });

class ClosedToMaintenanceModule {
}
ClosedToMaintenanceModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ClosedToMaintenanceModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
ClosedToMaintenanceModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ClosedToMaintenanceModule, declarations: [ClosedToMaintenanceComponent], imports: [CommonModule,
        MonkeyButtonModule,
        MonkeyIconModule,
        MonkeyInputModule,
        MonkeyModalModule,
        MonkeyExcPipesModule, i1$1.TranslateModule], exports: [ClosedToMaintenanceComponent] });
ClosedToMaintenanceModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ClosedToMaintenanceModule, imports: [[
            CommonModule,
            MonkeyButtonModule,
            MonkeyIconModule,
            MonkeyInputModule,
            MonkeyModalModule,
            MonkeyExcPipesModule,
            TranslateModule.forChild()
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: ClosedToMaintenanceModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [ClosedToMaintenanceComponent],
                    imports: [
                        CommonModule,
                        MonkeyButtonModule,
                        MonkeyIconModule,
                        MonkeyInputModule,
                        MonkeyModalModule,
                        MonkeyExcPipesModule,
                        TranslateModule.forChild()
                    ],
                    exports: [ClosedToMaintenanceComponent]
                }]
        }] });

class MonkeyExcProgressBarService {
    constructor(router) {
        this.router = router;
        this.init();
    }
    init() {
        this.visible = new BehaviorSubject(false);
        this.router.events
            .pipe(filter((event) => {
            return event instanceof NavigationStart;
        }))
            .subscribe(() => {
            this.show();
        });
        this.router.events
            .pipe(filter((event) => {
            return (event instanceof NavigationEnd ||
                event instanceof NavigationError ||
                event instanceof NavigationCancel);
        }))
            .subscribe(() => {
            this.hide();
        });
    }
    show() {
        this.visible.next(true);
    }
    hide() {
        this.visible.next(false);
    }
    visibleConfig() {
        return this.visible.asObservable();
    }
}
MonkeyExcProgressBarService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcProgressBarService, deps: [{ token: i1$3.Router }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcProgressBarService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcProgressBarService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcProgressBarService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return [{ type: i1$3.Router }]; } });

class MonkeyExcProgressBarComponent {
    constructor(progressBarService) {
        this.progressBarService = progressBarService;
        this.visible = false;
        //not to do
    }
    ngOnInit() {
        this.progressBarService.visibleConfig().subscribe((visible) => {
            this.visible = visible;
        });
    }
}
MonkeyExcProgressBarComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcProgressBarComponent, deps: [{ token: MonkeyExcProgressBarService }], target: i0.ɵɵFactoryTarget.Component });
MonkeyExcProgressBarComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.0.5", type: MonkeyExcProgressBarComponent, selector: "monkeyexc-progress-bar", ngImport: i0, template: "<ng-container *ngIf=\"visible\">\n  <progress class=\"monkey-progress monkey-progress__theme\"></progress>\n</ng-container>\n", styles: ["monkeyexc-progress-bar{position:absolute;width:100%;margin-top:-9.5px;z-index:99998}"], directives: [{ type: i1$2.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }], encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcProgressBarComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'monkeyexc-progress-bar',
                    templateUrl: './progress-bar.component.html',
                    styleUrls: ['./progress-bar.component.scss'],
                    encapsulation: ViewEncapsulation.None,
                }]
        }], ctorParameters: function () { return [{ type: MonkeyExcProgressBarService }]; } });

class MonkeyExcProgressBarModule {
}
MonkeyExcProgressBarModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcProgressBarModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MonkeyExcProgressBarModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcProgressBarModule, declarations: [MonkeyExcProgressBarComponent], imports: [CommonModule], exports: [MonkeyExcProgressBarComponent] });
MonkeyExcProgressBarModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcProgressBarModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcProgressBarModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [MonkeyExcProgressBarComponent],
                    imports: [CommonModule],
                    exports: [MonkeyExcProgressBarComponent],
                }]
        }] });

class VersionChangedComponent {
    onClose() {
        document.location.reload();
    }
}
VersionChangedComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: VersionChangedComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
VersionChangedComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.0.5", type: VersionChangedComponent, selector: "monkeyexc-version-changed", inputs: { config: "config", modalRef: "modalRef" }, ngImport: i0, template: "<monkey-modal [config]=\"config\" [modalRef]=\"modalRef\">\n  <div class=\"d-flex flex-column justify-content-center align-items-center\">\n    <span class=\"h2\">\n      {{ 'SCREENS.VERSION-CHANGED.TITLE' | translate }}\n    </span>\n    <span class=\"information-title mt-4\">\n      {{ 'SCREENS.VERSION-CHANGED.INFORMATION-1' | translate }}\n    </span>\n    <span class=\"information mt-3\">\n      {{ 'SCREENS.VERSION-CHANGED.INFORMATION-2' | translate }}\n    </span>\n  </div>\n  <div class=\"d-flex flex-column justify-content-center align-items-center mt-5\">\n    <monkey-button type=\"primary\" color=\"theme\" (click)=\"onClose()\">\n      {{ 'SCREENS.VERSION-CHANGED.BUTTONS.UPDATE-VERSION' | translate }}\n    </monkey-button>\n  </div>\n</monkey-modal>", styles: ["monkeyexc-version-changed .body{padding:24px;width:100%}monkeyexc-version-changed .information-title{font-weight:600;font-size:25px;line-height:32px}monkeyexc-version-changed .information,monkeyexc-version-changed .information-title{font-style:normal;display:flex;align-items:center;text-align:center;color:#4b4a53;max-width:600px}monkeyexc-version-changed .information{font-weight:400;font-size:20px;line-height:24px}monkeyexc-version-changed .browser-name{font-style:normal;font-weight:400;font-size:16px;line-height:24px;text-align:center;color:#9c9ca6}monkeyexc-version-changed .option{text-decoration:none;padding:4px;background:#eee;border:1px solid #d6d6d6;box-sizing:border-box;border-radius:16px}monkeyexc-version-changed monkey-modal mecx-monkey-modal .body{margin-bottom:0!important}"], components: [{ type: i1.MonkeyModalComponent, selector: "monkey-modal", inputs: ["onHandleConfirm", "config", "modalRef"] }, { type: i1.MonkeyButtonComponent, selector: "monkey-button", inputs: ["iconPosition", "disabled", "label", "icon", "type", "color"] }], pipes: { "translate": i1$1.TranslatePipe }, encapsulation: i0.ViewEncapsulation.None });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: VersionChangedComponent, decorators: [{
            type: Component,
            args: [{
                    selector: 'monkeyexc-version-changed',
                    templateUrl: './version-changed.component.html',
                    styleUrls: ['./version-changed.component.scss'],
                    encapsulation: ViewEncapsulation.None
                }]
        }], propDecorators: { config: [{
                type: Input
            }], modalRef: [{
                type: Input
            }] } });

class VersionChangedModule {
}
VersionChangedModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: VersionChangedModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
VersionChangedModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: VersionChangedModule, declarations: [VersionChangedComponent], imports: [CommonModule,
        MonkeyButtonModule,
        MonkeyIconModule,
        MonkeyInputModule,
        MonkeyModalModule, i1$1.TranslateModule], exports: [VersionChangedComponent] });
VersionChangedModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: VersionChangedModule, imports: [[
            CommonModule,
            MonkeyButtonModule,
            MonkeyIconModule,
            MonkeyInputModule,
            MonkeyModalModule,
            TranslateModule.forChild()
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: VersionChangedModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [VersionChangedComponent],
                    imports: [
                        CommonModule,
                        MonkeyButtonModule,
                        MonkeyIconModule,
                        MonkeyInputModule,
                        MonkeyModalModule,
                        TranslateModule.forChild()
                    ],
                    exports: [VersionChangedComponent]
                }]
        }] });

/* eslint-disable max-classes-per-file */
const moment = moment_;
class DateValidator {
    static do(control) {
        if (!control.parent || !control)
            return null;
        if (control && control.value) {
            const dateFormat = 'MM-DD-YYYY';
            if (!moment(moment(control.value).format(dateFormat), ['DD/MM/YYYY', 'MM-DD-YYYY', 'YYYY-MM-DD'], true).isValid()) {
                return {
                    invalidDate: true,
                };
            }
        }
        return null;
    }
}
class DocumentValidator {
    static do(control) {
        if (!control.parent || !control)
            return null;
        if (control && control.value) {
            if (!MonkeyExcUtils.isCPFCNPJValid(control.value)) {
                return {
                    invalidCpfCnpj: true,
                };
            }
        }
        return null;
    }
}
class ZipCodeValidator {
    static do(control) {
        if (!control.parent || !control)
            return null;
        if (control && control.value) {
            if (!MonkeyExcUtils.isValidZipCode(control.value)) {
                return {
                    invalidZipCode: true,
                };
            }
        }
        return null;
    }
}
class ComboValidator {
    static do(control) {
        if (!control.parent || !control)
            return null;
        if (control && control.value !== '0')
            return null;
        return {
            invalidCombo: true,
        };
    }
}
class isTrueValidator {
    static do(control) {
        if (!control.parent || !control)
            return null;
        if (control && control.value !== false)
            return null;
        return {
            invalidTrue: true,
        };
    }
}
class PasswordMatchValidation {
    static do(control) {
        if (!control.parent || !control)
            return null;
        const { parent } = control;
        const password = parent.get('password').value;
        const passwordConfirm = parent.get('passwordConfirm').value;
        if (!password || !passwordConfirm)
            return null;
        if (password === passwordConfirm)
            return null;
        return {
            passwordsNotMatching: true,
        };
    }
}
class UrlValidator {
    static do(control) {
        if (!control.parent || !control)
            return null;
        if (control && control.value) {
            if (!MonkeyExcUtils.isValidUrl(control.value)) {
                return {
                    invalidUrl: true,
                };
            }
        }
        return null;
    }
}
class CustomDatesStartValidator {
    static do(control) {
        if (!control.parent || !control)
            return null;
        const { parent } = control;
        const valueStart = parent.get('dateStart').value;
        const valueEnd = parent.get('dateEnd').value;
        let dateStart;
        let dateEnd;
        if (valueStart) {
            dateStart = new Date(valueStart);
        }
        if (valueEnd) {
            dateEnd = new Date(valueEnd);
        }
        if (!dateStart || !dateEnd)
            return null;
        if (dateStart > dateEnd) {
            return {
                dateStartMustBeLessThanAnd: true,
            };
        }
        return null;
    }
}
class CustomDatesEndValidator {
    static do(control) {
        if (!control.parent || !control)
            return null;
        const { parent } = control;
        const valueStart = parent.get('dateStart').value;
        const valueEnd = parent.get('dateEnd').value;
        let dateStart;
        let dateEnd;
        if (valueStart) {
            dateStart = new Date(valueStart);
        }
        if (valueEnd) {
            dateEnd = new Date(valueEnd);
        }
        if (!dateEnd || !dateStart)
            return null;
        if (dateEnd < dateStart) {
            return {
                dateEndMustBeGreaterThanStart: true,
            };
        }
        return null;
    }
}
class UnlockRegisterBuyerValidator {
    static do(control) {
        if (!control.parent || !control)
            return null;
        if (control && control.value !== '#MONKEYBUYER') {
            return {
                invalidUnlockRegister: true,
            };
        }
        return null;
    }
}
class UnlockRegisterSponsorValidator {
    static do(control) {
        if (!control.parent || !control)
            return null;
        if (control && control.value !== '#MONKEYSPONSOR') {
            return {
                invalidUnlockRegister: true,
            };
        }
        return null;
    }
}

var validateUtils = /*#__PURE__*/Object.freeze({
    __proto__: null,
    DateValidator: DateValidator,
    DocumentValidator: DocumentValidator,
    ZipCodeValidator: ZipCodeValidator,
    ComboValidator: ComboValidator,
    isTrueValidator: isTrueValidator,
    PasswordMatchValidation: PasswordMatchValidation,
    UrlValidator: UrlValidator,
    CustomDatesStartValidator: CustomDatesStartValidator,
    CustomDatesEndValidator: CustomDatesEndValidator,
    UnlockRegisterBuyerValidator: UnlockRegisterBuyerValidator,
    UnlockRegisterSponsorValidator: UnlockRegisterSponsorValidator
});

/* eslint-disable no-unused-vars */
/* eslint-disable no-shadow */
var MonkeyExcQueueEvents;
(function (MonkeyExcQueueEvents) {
    MonkeyExcQueueEvents[MonkeyExcQueueEvents["OnGoing"] = 0] = "OnGoing";
    MonkeyExcQueueEvents[MonkeyExcQueueEvents["Finished"] = 1] = "Finished";
    MonkeyExcQueueEvents[MonkeyExcQueueEvents["FinishedWithError"] = 2] = "FinishedWithError";
})(MonkeyExcQueueEvents || (MonkeyExcQueueEvents = {}));
var MonkeyExcDownloadEvents;
(function (MonkeyExcDownloadEvents) {
    MonkeyExcDownloadEvents[MonkeyExcDownloadEvents["OnGoing"] = 0] = "OnGoing";
    MonkeyExcDownloadEvents[MonkeyExcDownloadEvents["Finished"] = 1] = "Finished";
    MonkeyExcDownloadEvents[MonkeyExcDownloadEvents["FinishedWithError"] = 2] = "FinishedWithError";
})(MonkeyExcDownloadEvents || (MonkeyExcDownloadEvents = {}));
var MonkeyExcUploadEvents;
(function (MonkeyExcUploadEvents) {
    MonkeyExcUploadEvents[MonkeyExcUploadEvents["OnGoing"] = 0] = "OnGoing";
    MonkeyExcUploadEvents[MonkeyExcUploadEvents["Finished"] = 1] = "Finished";
    MonkeyExcUploadEvents[MonkeyExcUploadEvents["FinishedWithError"] = 2] = "FinishedWithError";
})(MonkeyExcUploadEvents || (MonkeyExcUploadEvents = {}));
// TODO pegar do json de config
var ApiEndPointsTokenNotMandatory;
(function (ApiEndPointsTokenNotMandatory) {
    ApiEndPointsTokenNotMandatory["Assets"] = "assets/";
    ApiEndPointsTokenNotMandatory["MonkeyExc"] = "/monkeyecx";
    ApiEndPointsTokenNotMandatory["ViaCep"] = "viacep.com.br/";
})(ApiEndPointsTokenNotMandatory || (ApiEndPointsTokenNotMandatory = {}));
// TODO pegar do json de config
var ApiEndPointsHeaderNotMandatory;
(function (ApiEndPointsHeaderNotMandatory) {
    ApiEndPointsHeaderNotMandatory["Assets"] = "/assets";
    ApiEndPointsHeaderNotMandatory["PayablesUpload"] = "payables-upload";
    ApiEndPointsHeaderNotMandatory["PictureUser"] = "/user-pictures";
    ApiEndPointsHeaderNotMandatory["Documents"] = "documents/";
    ApiEndPointsHeaderNotMandatory["BuyerTaxFile"] = "/buyer-tax-file";
    ApiEndPointsHeaderNotMandatory["ViaCep"] = "viacep.com.br/";
})(ApiEndPointsHeaderNotMandatory || (ApiEndPointsHeaderNotMandatory = {}));

var statics = /*#__PURE__*/Object.freeze({
    __proto__: null,
    get MonkeyExcQueueEvents () { return MonkeyExcQueueEvents; },
    get MonkeyExcDownloadEvents () { return MonkeyExcDownloadEvents; },
    get MonkeyExcUploadEvents () { return MonkeyExcUploadEvents; },
    get ApiEndPointsTokenNotMandatory () { return ApiEndPointsTokenNotMandatory; },
    get ApiEndPointsHeaderNotMandatory () { return ApiEndPointsHeaderNotMandatory; }
});

function buildQueuePropertys(queue) {
    const params = {
        item: Object.assign(Object.assign({}, queue), { id: MonkeyExcUtils.getRandomString(40) }),
        status: MonkeyExcQueueEvents.OnGoing,
    };
    return params;
}
function buildDownloadPropertys(name, description, size) {
    const params = {
        item: {
            name,
            description,
            id: `${MonkeyExcUtils.getRandomString(40)}`,
            size,
            createdAt: new Date(),
        },
        status: MonkeyExcQueueEvents.OnGoing,
    };
    return params;
}
function buildUploadPropertys(name, description) {
    const params = {
        item: {
            name,
            description,
            id: `${MonkeyExcUtils.getRandomString(40)}`,
        },
        status: MonkeyExcUploadEvents.OnGoing,
    };
    return params;
}
function hasMonkeyExcServiceAndHandlingProperties(context) {
    return Object.prototype.hasOwnProperty.call(context, 'monkeyecxService');
}

var decoratorsUtils = /*#__PURE__*/Object.freeze({
    __proto__: null,
    buildQueuePropertys: buildQueuePropertys,
    buildDownloadPropertys: buildDownloadPropertys,
    buildUploadPropertys: buildUploadPropertys,
    hasMonkeyExcServiceAndHandlingProperties: hasMonkeyExcServiceAndHandlingProperties
});

/* eslint-disable object-curly-newline */

function MonkeyExcCoreServiceConstructor() {
    return (target) => {
        Object.entries(target.prototype).forEach(([key, value]) => {
            const method = target.prototype[key];
            if (key !== 'constructor') {
                target.prototype[key] = function (...args) {
                    const context = this;
                    if (hasMonkeyExcServiceAndHandlingProperties(context)) {
                        context.monkeyexcService.monkeyexcHandlingService.clearAll();
                    }
                    const result = method.apply(context, args);
                    return result;
                };
            }
        });
        return target;
    };
}
function MonkeyExcCoreLog(tp) {
    return function (target, propertyName, propertyDescriptor) {
        const method = propertyDescriptor.value;
        propertyDescriptor.value = function (...args) {
            const params = args
                .map((a) => {
                return JSON.stringify(a);
            })
                .join();
            const result = method.apply(this, args);
            const r = JSON.stringify(result);
            console.log(`Call: ${propertyName}(${params}) => ${r}`);
            return result;
        };
        return propertyDescriptor;
    };
}
function MonkeyExcCoreClearDecorators() {
    return function (target, propertyName, propertyDescriptor) {
        const method = propertyDescriptor.value;
        propertyDescriptor.value = function (...args) {
            const context = this;
            if (hasMonkeyExcServiceAndHandlingProperties(context)) {
                context.monkeyexcService.monkeyexcHandlingService.clearAll();
            }
            const result = method.apply(context, args);
            return result;
        };
        return propertyDescriptor;
    };
}
function MonkeyExcCoreService(params) {
    return function (target, propertyName, propertyDescriptor) {
        const method = propertyDescriptor.value;
        propertyDescriptor.value = function (...args) {
            const context = this;
            if (hasMonkeyExcServiceAndHandlingProperties(context)) {
                context.monkeyexcService.monkeyexcHandlingService.clearAll();
                context.monkeyexcService.monkeyexcHandlingService.setMonkeyExcServiceCredentials(params);
            }
            const result = method.apply(context, args);
            return result;
        };
        return propertyDescriptor;
    };
}
function MonkeyExcCoreServicePaged(params) {
    return function (target, propertyName, propertyDescriptor) {
        const method = propertyDescriptor.value;
        propertyDescriptor.value = function (...args) {
            const context = this;
            if (hasMonkeyExcServiceAndHandlingProperties(context)) {
                const credentials = context.monkeyexcService.monkeyexcHandlingService.getMonkeyExcServiceCredentials();
                let requestPaged = null;
                if (credentials) {
                    requestPaged = credentials.requestPaged;
                }
                context.monkeyexcService.monkeyexcHandlingService.clearAll();
                context.monkeyexcService.monkeyexcHandlingService.setMonkeyExcServiceCredentials(Object.assign(Object.assign({}, params), (requestPaged || null)));
            }
            const result = method.apply(context, args);
            return result;
        };
        return propertyDescriptor;
    };
}
function MonkeyExcCoreServiceQueue(name, description, params) {
    return function (target, propertyName, propertyDescriptor) {
        const method = propertyDescriptor.value;
        propertyDescriptor.value = function (...args) {
            const context = this;
            if (hasMonkeyExcServiceAndHandlingProperties(context)) {
                if (MonkeyExcUtils.persistNullEmptyUndefined(params)) {
                    context.monkeyexcService.monkeyexcHandlingService.clearAll();
                    context.monkeyexcService.monkeyexcHandlingService.setMonkeyExcServiceCredentials(params);
                }
                context.monkeyexcService.monkeyexcHandlingService.setMonkeyExcRequestQueue(buildQueuePropertys({
                    name,
                    description,
                }));
            }
            const result = method.apply(context, args);
            return result;
        };
        return propertyDescriptor;
    };
}

/* eslint-disable space-before-function-paren */
function MonkeyExcServiceDownload(name, description, params) {
    return function (target, propertyName, propertyDescriptor) {
        const method = propertyDescriptor.value;
        propertyDescriptor.value = function (...args) {
            const context = this;
            if (hasMonkeyExcServiceAndHandlingProperties(context)) {
                if (MonkeyUtils.persistNullEmptyUndefined(params)) {
                    context.monkeyecxService.monkeyecxHandlingService.clearAll();
                    context.monkeyecxService.monkeyecxHandlingService.setMonkeyExcServiceCredentials(params);
                }
                context.monkeyecxService.monkeyecxHandlingService.setMonkeyExcRequestDownload(Object.assign({}, buildDownloadPropertys(name, description)));
            }
            const result = method.apply(context, args);
            return result;
        };
        return propertyDescriptor;
    };
}

/* eslint-disable space-before-function-paren */
function MonkeyExcServiceUpload(name, description, params) {
    return function (target, propertyName, propertyDescriptor) {
        const method = propertyDescriptor.value;
        propertyDescriptor.value = function (...args) {
            const context = this;
            if (hasMonkeyExcServiceAndHandlingProperties(context)) {
                if (MonkeyUtils.persistNullEmptyUndefined(params)) {
                    context.monkeyecxService.monkeyecxHandlingService.clearAll();
                    context.monkeyecxService.monkeyecxHandlingService.setMonkeyExcServiceCredentials(params);
                }
                context.monkeyecxService.monkeyecxHandlingService.setMonkeyExcRequestUpload(Object.assign({}, buildUploadPropertys(name, description)));
            }
            const result = method.apply(context, args);
            return result;
        };
        return propertyDescriptor;
    };
}

class MonkeyExcDragDropDirective {
    constructor() {
        this.onFileDropped = new EventEmitter();
        this.background = '#f5fcff';
        this.opacity = '1';
    }
    onDragOver(evt) {
        evt.preventDefault();
        evt.stopPropagation();
        this.background = '#9ecbec';
        this.opacity = '0.8';
    }
    onDragLeave(evt) {
        evt.preventDefault();
        evt.stopPropagation();
        this.background = '#f5fcff';
        this.opacity = '1';
    }
    ondrop(evt) {
        evt.preventDefault();
        evt.stopPropagation();
        this.background = '#f5fcff';
        this.opacity = '1';
        const { files } = evt.dataTransfer;
        if (files.length > 0) {
            this.onFileDropped.emit(files);
        }
    }
}
MonkeyExcDragDropDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDragDropDirective, deps: [], target: i0.ɵɵFactoryTarget.Directive });
MonkeyExcDragDropDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: MonkeyExcDragDropDirective, selector: "[monkeyexcDragDrop]", outputs: { onFileDropped: "onFileDropped" }, host: { listeners: { "dragover": "onDragOver($event)", "dragleave": "onDragLeave($event)", "drop": "ondrop($event)" }, properties: { "style.background-color": "this.background", "style.opacity": "this.opacity" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDragDropDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[monkeyexcDragDrop]'
                }]
        }], propDecorators: { onFileDropped: [{
                type: Output
            }], background: [{
                type: HostBinding,
                args: ['style.background-color']
            }], opacity: [{
                type: HostBinding,
                args: ['style.opacity']
            }], onDragOver: [{
                type: HostListener,
                args: ['dragover', ['$event']]
            }], onDragLeave: [{
                type: HostListener,
                args: ['dragleave', ['$event']]
            }], ondrop: [{
                type: HostListener,
                args: ['drop', ['$event']]
            }] } });

class MonkeyExcFormatCurrency {
    constructor(elementRef, injector) {
        this.elementRef = elementRef;
        this.injector = injector;
        this.currencyCode = 'BRL';
        this.currentLocale = 'pt-BR';
        this.el = this.elementRef.nativeElement;
        this.currency = this.injector.get(CurrencyPipe);
        const translateService = this.injector.get(TranslateService);
        translateService.get('MONKEY-CURRENCY-CODE').subscribe((_) => {
            this.currencyCode = _;
            this.currentLocale = translateService.getDefaultLang();
        });
    }
    handle(value) {
        const { currencyCode, currentLocale } = this;
        const newValue = MonkeyExcUtils.handleOnlyNumbers(value);
        return this.currency.transform(newValue / 100, currencyCode, 'symbol', '', currentLocale);
    }
    ngOnInit() {
        this.el.value = this.handle(this.el.value);
    }
    onInput(value) {
        this.el.value = this.handle(value);
    }
}
MonkeyExcFormatCurrency.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatCurrency, deps: [{ token: i0.ElementRef }, { token: i0.Injector }], target: i0.ɵɵFactoryTarget.Directive });
MonkeyExcFormatCurrency.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: MonkeyExcFormatCurrency, selector: "[monkeyexcFormatCurrency]", host: { listeners: { "input": "onInput($event.target.value)" } }, providers: [CurrencyPipe], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatCurrency, decorators: [{
            type: Directive,
            args: [{
                    selector: '[monkeyexcFormatCurrency]',
                    providers: [CurrencyPipe]
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Injector }]; }, propDecorators: { onInput: [{
                type: HostListener,
                args: ['input', ['$event.target.value']]
            }] } });

class MonkeyExcFormatUpper {
    constructor(_el, _renderer) {
        this._el = _el;
        this._renderer = _renderer;
        // not to do
    }
    onKeyDown(evt) {
        const value = this._el.nativeElement.value.toUpperCase();
        this._renderer.setProperty(this._el.nativeElement, 'value', value);
        this._onChange(value);
        evt.preventDefault();
    }
    onBlur() {
        this._touched();
    }
    writeValue(value) {
        this._renderer.setProperty(this._el.nativeElement, 'value', value);
    }
    registerOnChange(fn) {
        this._onChange = fn;
    }
    registerOnTouched(fn) {
        this._touched = fn;
    }
    setDisabledState(isDisabled) {
        this._renderer.setProperty(this._el.nativeElement, 'disabled', isDisabled);
    }
}
MonkeyExcFormatUpper.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatUpper, deps: [{ token: i0.ElementRef, self: true }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive });
MonkeyExcFormatUpper.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: MonkeyExcFormatUpper, selector: "[monkeyexcFormatUpper]", host: { listeners: { "keyup": "onKeyDown($event)", "blur": "onBlur($event)" } }, providers: [
        {
            provide: NG_VALUE_ACCESSOR,
            useExisting: forwardRef(() => {
                // eslint-disable-next-line no-use-before-define
                return MonkeyExcFormatUpper;
            }),
            multi: true
        }
    ], ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFormatUpper, decorators: [{
            type: Directive,
            args: [{
                    selector: '[monkeyexcFormatUpper]',
                    providers: [
                        {
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(() => {
                                // eslint-disable-next-line no-use-before-define
                                return MonkeyExcFormatUpper;
                            }),
                            multi: true
                        }
                    ]
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef, decorators: [{
                    type: Self
                }] }, { type: i0.Renderer2 }]; }, propDecorators: { onKeyDown: [{
                type: HostListener,
                args: ['keyup', ['$event']]
            }], onBlur: [{
                type: HostListener,
                args: ['blur', ['$event']]
            }] } });

class MonkeyExcOnlyAlphaNumericDirective {
    constructor(elementRef) {
        this.elementRef = elementRef;
        // not to do
    }
    onInputChange(event) {
        const initalValue = this.elementRef.nativeElement.value;
        this.elementRef.nativeElement.value = MonkeyExcUtils.handleOnlyAlphaNumeric(initalValue);
        if (initalValue !== this.elementRef.nativeElement.value) {
            event.stopPropagation();
        }
    }
}
MonkeyExcOnlyAlphaNumericDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcOnlyAlphaNumericDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
MonkeyExcOnlyAlphaNumericDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: MonkeyExcOnlyAlphaNumericDirective, selector: "[monkeyexcOnlyAlphaNumeric]", host: { listeners: { "input": "onInputChange($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcOnlyAlphaNumericDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[monkeyexcOnlyAlphaNumeric]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { onInputChange: [{
                type: HostListener,
                args: ['input', ['$event']]
            }] } });

class MonkeyExcOnlyNumbersDirective {
    constructor(elementRef) {
        this.elementRef = elementRef;
        // not to do
    }
    onInputChange(event) {
        const initalValue = this.elementRef.nativeElement.value;
        this.elementRef.nativeElement.value = MonkeyExcUtils.handleOnlyNumbers(initalValue);
        if (initalValue !== this.elementRef.nativeElement.value) {
            event.stopPropagation();
        }
    }
}
MonkeyExcOnlyNumbersDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcOnlyNumbersDirective, deps: [{ token: i0.ElementRef }], target: i0.ɵɵFactoryTarget.Directive });
MonkeyExcOnlyNumbersDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: MonkeyExcOnlyNumbersDirective, selector: "[monkeyexcOnlyNumbers]", host: { listeners: { "input": "onInputChange($event)" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcOnlyNumbersDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[monkeyexcOnlyNumbers]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }]; }, propDecorators: { onInputChange: [{
                type: HostListener,
                args: ['input', ['$event']]
            }] } });

class MonkeyExcRequestPagedHandling {
    constructor(_url, _pagedParams) {
        this.url = _url;
        this.pagedParams = _pagedParams || {
            page: {}
        };
    }
    handlePagedValuesFromApi(url) {
        if (url.search('\\?') < 0)
            return url;
        const params = url.substr(url.search('\\?') + 1, url.length);
        url = url.substr(0, url.search('\\?'));
        return `${url}?${new HttpParams({
            fromString: params
        }).delete('size').delete('page').toString()}`;
    }
    getUrlParams(url) {
        const { pagedParams } = this;
        const { number, size } = pagedParams === null || pagedParams === void 0 ? void 0 : pagedParams.page;
        const hasInitialQueryParams = url.search('\\?') > 0;
        return `${!hasInitialQueryParams ? '?' : '&'}page=${number || 0}&size=${size || 20}`;
    }
    getRequestWithPagedParams() {
        const { url } = this;
        const handled = this.handlePagedValuesFromApi(url);
        return `${handled}${this.getUrlParams(handled)}`;
    }
}

class MonkeyExcCommonsService {
    constructor(monkeyexcService, tokenStorage, otherArgs) {
        this.monkeyexcService = monkeyexcService;
        this.tokenStorage = tokenStorage;
        this.otherArgs = otherArgs;
        this.flagValidator = true;
        this.__requestPaged = null;
        this.__onSearchChanged$ = new BehaviorSubject(null);
        this.__onDataChanged$ = new BehaviorSubject(null);
        this.__onLoadingInProgress$ = new BehaviorSubject(false);
        this.__onDataDeleted$ = new BehaviorSubject(null);
        this.__onErrorChanged$ = new BehaviorSubject(null);
        this.__onGovernmentIdDataChanged$ = new BehaviorSubject(null);
        this.__onZipCodeDataChanged$ = new BehaviorSubject(null);
        this.__oni18nDataChanged$ = new BehaviorSubject(null);
        this.__onDoSearch$ = new BehaviorSubject(null);
        this.__onDoPagination$ = new BehaviorSubject(null);
        this.handleInit();
    }
    handleInit() {
        var _a, _b, _c;
        if (this.tokenStorage) {
            this.__tokenCredentials = this.tokenStorage.getToken();
        }
        if ((_a = this.otherArgs) === null || _a === void 0 ? void 0 : _a.router) {
            const { clearOnChangeRoute } = (_c = (_b = this.otherArgs) === null || _b === void 0 ? void 0 : _b.schedule) === null || _c === void 0 ? void 0 : _c.options;
            this.otherArgs.router.events
                .pipe(filter((event) => {
                return event instanceof NavigationStart;
            }), take(1))
                .subscribe(() => {
                var _a, _b, _c;
                if (this.__schedule && clearOnChangeRoute) {
                    (_c = (_b = (_a = this.otherArgs) === null || _a === void 0 ? void 0 : _a.schedule) === null || _b === void 0 ? void 0 : _b.service) === null || _c === void 0 ? void 0 : _c.removeSchedule(this.__schedule);
                    this.__schedule = null;
                }
            });
        }
    }
    getRole() {
        const { __tokenCredentials } = this;
        if (!__tokenCredentials)
            return '';
        if ((__tokenCredentials === null || __tokenCredentials === void 0 ? void 0 : __tokenCredentials.programAdmin) === 'true') {
            return 'PROGRAM_ADMIN';
        }
        return (__tokenCredentials === null || __tokenCredentials === void 0 ? void 0 : __tokenCredentials.role) || '';
    }
    allowedSecurityAccess(args) {
        if (!args)
            return true;
        const roles = args === null || args === void 0 ? void 0 : args.roles;
        const byExclusion = args === null || args === void 0 ? void 0 : args.byExclusion;
        const found = roles === null || roles === void 0 ? void 0 : roles.indexOf(this.getRole());
        let ret = false;
        if (byExclusion) {
            ret = true;
            if (found > -1) {
                ret = false;
            }
        }
        else {
            ret = false;
            if (found > -1) {
                ret = true;
            }
        }
        if (!roles || roles.length === 0 || this.getRole() === 'PROGRAM_ADMIN')
            ret = true;
        return ret;
    }
    navigateToErrorPage(statusCode, router) {
        const routes = {
            403: 'forbidden',
            404: 'not-found',
            500: 'service-problems',
            503: 'service-problems',
        };
        if (!router) {
            // eslint-disable-next-line no-console
            console.error('Router must be declared');
        }
        else {
            router.navigate([`/app/pages/${routes[statusCode]}`.toLowerCase()], {
                skipLocationChange: true,
            });
        }
    }
    setPage(requestPaged) {
        this.__requestPaged = Object.assign(Object.assign({}, this.__requestPaged), requestPaged);
        return this;
    }
    nextPage() {
        if (!this.__requestPaged)
            return false;
        const { page } = this.__requestPaged;
        const { number, totalPages } = page;
        if (number < totalPages) {
            this.__requestPaged = Object.assign(Object.assign({}, this.__requestPaged), { page: Object.assign(Object.assign({}, page), { number: number + 1 }) });
            return true;
        }
        return false;
    }
    getEmbeddedData(data, field) {
        const { _embedded } = data;
        return _embedded ? _embedded[field] : null;
    }
    getNormalizedUrl(url) {
        const { __requestPaged } = this;
        return new MonkeyExcRequestPagedHandling(url, __requestPaged).getRequestWithPagedParams();
    }
    clear(clearData) {
        var _a, _b, _c;
        if (clearData) {
            this.__data = null;
            this.__requestPaged = null;
            this.__params = null;
            this.__page = null;
            if (this.__schedule) {
                const { queue } = this.__schedule;
                if (queue) {
                    this.otherArgs.queue.service.removeQueueItem(queue);
                }
                (_c = (_b = (_a = this.otherArgs) === null || _a === void 0 ? void 0 : _a.schedule) === null || _b === void 0 ? void 0 : _b.service) === null || _c === void 0 ? void 0 : _c.removeSchedule(this.__schedule);
                this.__schedule = null;
            }
        }
        this.__error = null;
        this.__handledError = null;
        this.flagValidator = false;
    }
    resolve(route, state, otherArgs) {
        var _a, _b, _c;
        this.__data = null;
        this.__page = null;
        this.__requestPaged = null;
        this.flagValidator = true;
        if (this.tokenStorage) {
            this.__tokenCredentials = this.tokenStorage.getToken();
        }
        if (this.allowedSecurityAccess(otherArgs === null || otherArgs === void 0 ? void 0 : otherArgs.security)) {
            Object.entries(this).forEach(([key, value]) => {
                if (value instanceof BehaviorSubject) {
                    this[key] = new BehaviorSubject(null);
                }
            });
            if (this.__schedule) {
                (_c = (_b = (_a = this.otherArgs) === null || _a === void 0 ? void 0 : _a.schedule) === null || _b === void 0 ? void 0 : _b.service) === null || _c === void 0 ? void 0 : _c.removeSchedule(this.__schedule);
                this.__schedule = null;
            }
            const { __requestPaged } = this;
            if (!__requestPaged) {
                this.setPage({
                    page: {
                        number: 0,
                        size: 10,
                    },
                });
            }
            if (otherArgs === null || otherArgs === void 0 ? void 0 : otherArgs.callbackPagination) {
                this.__onDoPagination$.subscribe(() => {
                    if (!this.__onLoadingInProgress$.value) {
                        const hasMorePages = this.setPage({
                            page: Object.assign({}, this.__page),
                        }).nextPage();
                        if (hasMorePages && (otherArgs === null || otherArgs === void 0 ? void 0 : otherArgs.callbackPagination))
                            otherArgs.callbackPagination();
                    }
                });
            }
            if (otherArgs === null || otherArgs === void 0 ? void 0 : otherArgs.translateOptions) {
                const { service, keys } = otherArgs.translateOptions;
                this.geti18n(service, keys);
            }
            if (otherArgs === null || otherArgs === void 0 ? void 0 : otherArgs.feature) {
                const { flag, service } = otherArgs.feature;
                service.onFlags
                    .pipe(takeWhile(() => {
                    return this.flagValidator;
                }))
                    .subscribe((val) => {
                    if (val) {
                        const hasFlag = service.getFlag(flag);
                        if (MonkeyExcUtils.persistNullEmptyUndefined(hasFlag)) {
                            if (!hasFlag) {
                                this.navigateToErrorPage(404, otherArgs.router);
                                return;
                            }
                        }
                        otherArgs === null || otherArgs === void 0 ? void 0 : otherArgs.callbackMain();
                    }
                });
            }
            else {
                otherArgs === null || otherArgs === void 0 ? void 0 : otherArgs.callbackMain();
            }
        }
        else {
            this.navigateToErrorPage(403, otherArgs.router);
        }
    }
    getHTTPHeaderApplicationPDF() {
        return {
            observe: 'response',
            responseType: 'blob',
        };
    }
    genericMethod(link, data, callback) {
        const { href, type } = link;
        this.monkeyexcService[type.toLowerCase()](`${href}`, data).subscribe((resp) => {
            if (callback)
                callback();
        }, (err) => {
            throwError(err);
        });
    }
    geti18n(translateService, keys) {
        translateService
            .getStreamOnTranslationChange(keys)
            .subscribe((translations) => {
            this.__i18n = translations;
            this.__oni18nDataChanged$.next(null);
        });
    }
}
__decorate([
    MonkeyExcCoreService({
        requestInProgress: {
            showProgress: true,
        },
    })
], MonkeyExcCommonsService.prototype, "genericMethod", null);

/* eslint-disable max-len */
class MonkeyExcHandlingService {
    clearAll() {
        this.monkeyexcServiceCredentials = null;
        this.monkeyexcRequestQueue = null;
        this.monkeyexcRequestDownload = null;
        this.monkeyexcRequestUpload = null;
    }
    setMonkeyExcServiceCredentials(param) {
        this.monkeyexcServiceCredentials = param;
    }
    getMonkeyExcServiceCredentials() {
        return this.monkeyexcServiceCredentials;
    }
    setMonkeyExcRequestQueue(queue) {
        this.monkeyexcRequestQueue = queue;
    }
    getMonkeyExcRequestQueue() {
        return this.monkeyexcRequestQueue;
    }
    setMonkeyExcRequestDownload(download) {
        this.monkeyexcRequestDownload = download;
    }
    getMonkeyExcRequestDownload() {
        return this.monkeyexcRequestDownload;
    }
    setMonkeyExcRequestUpload(upload) {
        this.monkeyexcRequestUpload = upload;
    }
    getMonkeyExcRequestUpload() {
        return this.monkeyexcRequestUpload;
    }
}
MonkeyExcHandlingService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHandlingService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcHandlingService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHandlingService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHandlingService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }] });

class MonkeyExcService {
    constructor(http, monkeyexcHandlingService) {
        this.http = http;
        this.monkeyexcHandlingService = monkeyexcHandlingService;
        // not to do
    }
    handlelize(params) {
        if (!params) {
            return params;
        }
        // eslint-disable-next-line no-restricted-syntax
        for (const field of [
            'createdAt',
            'createUserId',
            'updatedAt',
            'lastUserId',
            '_links',
            'governmentIdType',
            'governmentIdMask',
            'screenType',
            'screenTab'
        ]) {
            delete params[field];
        }
        return params;
    }
    get(url, options) {
        return this.http.get(url, options);
    }
    post(url, params, options) {
        return this.http.post(url, params, options);
    }
    put(url, params) {
        return this.http.put(url, this.handlelize(Object.assign({}, params)));
    }
    delete(url, params) {
        return this.http.delete(url, params);
    }
    download(url, options, filename) {
        this.http.get(url, options).subscribe((resp) => {
            const { headers, body } = resp;
            const contentType = headers.get('Content-Type');
            const contentDisposition = headers.get('Content-Disposition');
            if (contentDisposition) {
                filename = contentDisposition
                    .split(';')[1]
                    .split('filename')[1]
                    .split('=')[1]
                    .trim()
                    .replace(new RegExp(/"/g), '');
            }
            const blob = new Blob([body], {
                type: `${contentType}`
            });
            return {
                filename,
                blob
            };
        }, (err) => {
            throwError(err);
        });
    }
    downloadOb(url, options, filename) {
        return this.http.get(url, options).pipe(map((resp) => {
            const { headers, body } = resp;
            const contentType = headers.get('Content-Type');
            const contentDisposition = headers.get('Content-Disposition');
            if (contentDisposition) {
                filename = contentDisposition
                    .split(';')[1]
                    .split('filename')[1]
                    .split('=')[1]
                    .trim()
                    .replace(new RegExp(/"/g), '');
            }
            const blob = new Blob([body], {
                type: `${contentType}`
            });
            return {
                filename,
                blob
            };
        }), catchError((err) => {
            return throwError(err);
        }));
    }
}
MonkeyExcService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcService, deps: [{ token: i1$4.HttpClient }, { token: MonkeyExcHandlingService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1$4.HttpClient }, { type: MonkeyExcHandlingService }]; } });

/* eslint-disable object-curly-newline */
class MonkeyExcCookieStorageService {
    constructor(document) {
        this.document = document;
        // not to do
    }
    getCookieRegExp(name) {
        const escapedName = name.replace(/([[\]{}()|=;+?,.*^$])/gi, '\\$1');
        return new RegExp(`(?:^${escapedName}|;\\s*${escapedName})=(.*?)(?:;|$)`, 'g');
    }
    safeDecodeURIComponent(encodedURIComponent) {
        try {
            return decodeURIComponent(encodedURIComponent);
        }
        catch (_a) {
            return encodedURIComponent;
        }
    }
    check(name) {
        name = encodeURIComponent(name);
        const regExp = this.getCookieRegExp(name);
        return regExp.test(this.document.cookie);
    }
    set(name, value, expiresOrOptions, path, domain, secure, sameSite) {
        if (typeof expiresOrOptions === 'number' ||
            expiresOrOptions instanceof Date ||
            path ||
            domain ||
            secure ||
            sameSite) {
            const optionsBody = {
                expires: expiresOrOptions,
                path,
                domain,
                secure,
                sameSite: sameSite || 'Lax'
            };
            this.set(name, value, optionsBody);
            return;
        }
        let cookieString = `${encodeURIComponent(name)}=${encodeURIComponent(value)};`;
        const options = expiresOrOptions || {};
        if (options.expires) {
            if (typeof options.expires === 'number') {
                const dateExpires = new Date(new Date().getTime() + options.expires * 1000 * 60 * 60 * 24);
                cookieString += `expires=${dateExpires.toUTCString()};`;
            }
            else {
                cookieString += `expires=${options.expires.toUTCString()};`;
            }
        }
        if (options.path) {
            cookieString += `path=${options.path};`;
        }
        if (options.domain) {
            cookieString += `domain=${options.domain};`;
        }
        if (options.secure === false && options.sameSite === 'None') {
            options.secure = true;
        }
        if (options.secure) {
            cookieString += 'secure;';
        }
        if (!options.sameSite) {
            options.sameSite = 'Lax';
        }
        cookieString += `sameSite=${options.sameSite};`;
        this.document.cookie = cookieString;
    }
    get(name) {
        if (this.check(name)) {
            name = encodeURIComponent(name);
            const regExp = this.getCookieRegExp(name);
            const result = regExp.exec(this.document.cookie);
            return result[1] ? this.safeDecodeURIComponent(result[1]) : '';
        }
        return '';
    }
    remove(name, path, domain, secure, sameSite = 'Lax') {
        const expiresDate = new Date('Thu, 01 Jan 1970 00:00:01 GMT');
        this.set(name, '', { expires: expiresDate, path, domain, secure, sameSite });
    }
}
MonkeyExcCookieStorageService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcCookieStorageService, deps: [{ token: DOCUMENT }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcCookieStorageService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcCookieStorageService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcCookieStorageService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: undefined, decorators: [{
                    type: Inject,
                    args: [DOCUMENT]
                }] }]; } });

class MonkeyExci18nConfigService extends MonkeyExcCommonsService {
    constructor(monkeyexcService, translateService, monkeyexcCookieStorageService) {
        super(monkeyexcService);
        this.translateService = translateService;
        this.monkeyexcCookieStorageService = monkeyexcCookieStorageService;
        this.translateService.addLangs(['pt-BR', 'en-US']);
        this.translateService.setDefaultLang('pt-BR');
        this.translateService.use('pt-BR');
        this.applyLocal();
    }
    applyLocal() {
        registerLocaleData(localePTBR, 'pt-PT');
    }
    apply(params, environment, change = false) {
        const { monkeyexcService, monkeyexcCookieStorageService } = this;
        let { i18n } = params;
        const cookie = monkeyexcCookieStorageService.get('monkey-app-locale');
        if (cookie && !change) {
            i18n = JSON.parse(atob(cookie));
        }
        else {
            monkeyexcCookieStorageService.set('monkey-app-locale', btoa(JSON.stringify(i18n)));
        }
        monkeyexcService
            .get(`${environment.urlSettings}/i18n/${i18n.lang}.json`)
            .subscribe((config) => {
            const { lang, data } = config;
            this.translateService.setTranslation(lang, data, true);
            this.translateService.use(lang);
        }, (err) => {
            console.error(`i18n ${i18n.lang} not found!`);
            throwError(err);
        });
    }
}
MonkeyExci18nConfigService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExci18nConfigService, deps: [{ token: MonkeyExcService }, { token: i1$1.TranslateService }, { token: MonkeyExcCookieStorageService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExci18nConfigService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExci18nConfigService, providedIn: 'root' });
__decorate([
    MonkeyExcCoreService({
        httpResponse: {
            httpCodeIgnore: [404],
        },
        requestInProgress: {
            showProgress: false,
        },
    })
], MonkeyExci18nConfigService.prototype, "apply", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExci18nConfigService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return [{ type: MonkeyExcService }, { type: i1$1.TranslateService }, { type: MonkeyExcCookieStorageService }]; }, propDecorators: { apply: [] } });

class MonkeyExcLogsConfigService {
    apply(params, configBoostrap, environment, identifyCode) {
        const { program, logs } = params;
        if ((logs === null || logs === void 0 ? void 0 : logs.enabled) &&
            environment.production &&
            (environment === null || environment === void 0 ? void 0 : environment.dataDogApplicationId) &&
            (environment === null || environment === void 0 ? void 0 : environment.dataDogClientToken)) {
            datadogRum.init({
                applicationId: environment === null || environment === void 0 ? void 0 : environment.dataDogApplicationId,
                clientToken: environment === null || environment === void 0 ? void 0 : environment.dataDogClientToken,
                service: program.token,
                site: 'datadoghq.com',
                sampleRate: 100,
                env: `monkeyexc-front-${identifyCode}-${environment.environment}`,
                version: configBoostrap === null || configBoostrap === void 0 ? void 0 : configBoostrap.version,
                trackInteractions: true,
            });
        }
    }
}
MonkeyExcLogsConfigService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcLogsConfigService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcLogsConfigService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcLogsConfigService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcLogsConfigService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }] });

class MonkeyExcServiceWorkerConfigService {
    constructor(appRef, updates, modalService) {
        this.appRef = appRef;
        this.updates = updates;
        this.modalService = modalService;
        // not to do
    }
    handleValidation(config) {
        var _a;
        const { updates, modalService } = this;
        (_a = updates === null || updates === void 0 ? void 0 : updates.available) === null || _a === void 0 ? void 0 : _a.subscribe(() => {
            if (!config.showNewVersion || config.maintenance.closed) {
                document.location.reload();
            }
            else {
                modalService.open(VersionChangedComponent, {
                    color: 'theme',
                    size: 'md'
                });
            }
        });
    }
    verify() {
        const { appRef, updates } = this;
        const appIsStable$ = appRef.isStable
            .pipe(first((isStable) => { return isStable === true; }));
        const everyHour$ = interval(1 * 60 * 60 * 1000);
        const everyHourOnceAppIsStable$ = concat(appIsStable$, everyHour$);
        everyHourOnceAppIsStable$.subscribe(() => {
            updates.checkForUpdate();
        });
        updates.checkForUpdate();
    }
    apply(config) {
        this.handleValidation(config);
        this.verify();
    }
}
MonkeyExcServiceWorkerConfigService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcServiceWorkerConfigService, deps: [{ token: i0.ApplicationRef }, { token: i1$5.SwUpdate }, { token: i1.MonkeyStyleGuideModalService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcServiceWorkerConfigService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcServiceWorkerConfigService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcServiceWorkerConfigService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i0.ApplicationRef }, { type: i1$5.SwUpdate }, { type: i1.MonkeyStyleGuideModalService }]; } });

/* eslint-disable no-console */
class MonkeyExcSecurityConsoleConfigService extends MonkeyExcCommonsService {
    constructor(translateService) {
        super();
        this.translateService = translateService;
        this.geti18n(this.translateService, 'SERVICES.WARNING.CONSOLE');
    }
    handleValidation() {
        this.__oni18nDataChanged$.subscribe(() => {
            const { __i18n } = this;
            const title = __i18n === null || __i18n === void 0 ? void 0 : __i18n.TITLE;
            const message = __i18n === null || __i18n === void 0 ? void 0 : __i18n.MESSAGE;
            if (title) {
                console.log(`%c${title}`, 'background: #f2f061; color: #ff0000; font-size: x-large');
                console.log(`%c${message}`, 'font-size: x-large');
                console.log('%c  __  __             _             ______   \n ' +
                    '|  \\/  | ___  _ __ | | _____ _   _\\ \\ \\ \\  \n ' +
                    "| |\\/| |/ _ \\| '_ \\| |/ / _ \\ | | |\\ \\ \\ \\ \n " +
                    '| |  | | (_) | | | |   <  __/ |_| |/ / / / \n ' +
                    '|_|  |_|\\___/|_| |_|_|\\_\\___|\\__, /_/_/_/  \n ' +
                    '                             |___/         \n ' +
                    'Join us: https://monkeyecx.gupy.io', 'background: #1976d2; color: #fff');
            }
        });
    }
    apply() {
        this.handleValidation();
    }
}
MonkeyExcSecurityConsoleConfigService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcSecurityConsoleConfigService, deps: [{ token: i1$1.TranslateService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcSecurityConsoleConfigService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcSecurityConsoleConfigService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcSecurityConsoleConfigService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1$1.TranslateService }]; } });

class MonkeyExcMaintenanceConfigService {
    constructor(modalService, router) {
        this.modalService = modalService;
        this.router = router;
        // not to do
    }
    handleValidation(config) {
        if (config.maintenance.closed) {
            localStorage.clear();
            this.router.navigate(['']);
            setTimeout(() => {
                this.modalService.open(ClosedToMaintenanceComponent, {
                    color: 'theme',
                    size: 'md',
                    data: config
                });
            }, 200);
        }
    }
    apply(config) {
        this.handleValidation(config);
    }
}
MonkeyExcMaintenanceConfigService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcMaintenanceConfigService, deps: [{ token: i1.MonkeyStyleGuideModalService }, { token: i1$3.Router }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcMaintenanceConfigService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcMaintenanceConfigService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcMaintenanceConfigService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1.MonkeyStyleGuideModalService }, { type: i1$3.Router }]; } });

class MonkeyExcConfigService extends MonkeyExcCommonsService {
    constructor(monkeyexcService, monkeyexci18nConfigService, monkeyexcLogsConfigService, monkeyStyleGuideSettingsService, monkeyexcServiceWorkerConfigService, monkeyexcSecurityConsoleConfigService, monkeyexcMaintenanceConfigService) {
        super(monkeyexcService);
        this.monkeyexci18nConfigService = monkeyexci18nConfigService;
        this.monkeyexcLogsConfigService = monkeyexcLogsConfigService;
        this.monkeyStyleGuideSettingsService = monkeyStyleGuideSettingsService;
        this.monkeyexcServiceWorkerConfigService = monkeyexcServiceWorkerConfigService;
        this.monkeyexcSecurityConsoleConfigService = monkeyexcSecurityConsoleConfigService;
        this.monkeyexcMaintenanceConfigService = monkeyexcMaintenanceConfigService;
        this.configSubject$ = new BehaviorSubject(null);
        this.configBoostrapSubject$ = new BehaviorSubject(null);
    }
    internalValidations(...args) {
        const { monkeyexcServiceWorkerConfigService, monkeyexcSecurityConsoleConfigService, monkeyexcMaintenanceConfigService } = this;
        const configBoostrap = args[0];
        const callback = args[1];
        monkeyexcSecurityConsoleConfigService.apply();
        monkeyexcServiceWorkerConfigService.apply(configBoostrap);
        monkeyexcMaintenanceConfigService.apply(configBoostrap);
        callback(configBoostrap);
    }
    getWhiteLabelSettings(monkeyexcCode, configBoostrap = null, callback, environment, identifyCode) {
        const { monkeyexcService, monkeyexci18nConfigService, configSubject$, monkeyStyleGuideSettingsService, monkeyexcLogsConfigService, internalValidations } = this;
        monkeyexcService
            .get(`${environment.urlAssets}/monkeyexc/${monkeyexcCode.toLowerCase()}/white-label.json`)
            .subscribe((config) => {
            monkeyexci18nConfigService.apply(config, environment);
            monkeyexcLogsConfigService.apply(config, configBoostrap, environment, identifyCode);
            monkeyStyleGuideSettingsService.boostrap(`${environment.urlAssets}/monkeyexc/${monkeyexcCode.toLowerCase()}/monkey-style-guide-settings.json`, internalValidations.bind(this, configBoostrap, callback, environment));
            configSubject$.next(config);
        }, (err) => {
            console.error('Program Configuration not found!');
            throwError(err);
        });
    }
    init(callback, environment, identifyCode, monkeyexcCode) {
        const { monkeyexcService, configBoostrapSubject$ } = this;
        monkeyexcService
            .get(`/assets/boostrap.json?t=${MonkeyUtils.getRandomString(30)}`, {
            observe: 'response'
        })
            .subscribe((resp) => {
            const { headers, body } = resp;
            const monkeyCode = headers.get('monkey-code') || monkeyexcCode;
            console.log('monkeycode');
            console.log(monkeyCode);
            if (monkeyCode) {
                this.getWhiteLabelSettings(monkeyCode, body, callback, environment, identifyCode);
                configBoostrapSubject$.next(body);
            }
            else {
                console.error(`Boostrap ${monkeyCode} Configuration not found!`);
            }
        }, (err) => {
            console.log(err);
            console.error('Boostrap Configuration not found!');
            throwError(err);
        });
    }
    config() {
        return this.configSubject$.asObservable();
    }
    boostrapConfig() {
        return this.configBoostrapSubject$.asObservable();
    }
}
MonkeyExcConfigService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcConfigService, deps: [{ token: MonkeyExcService }, { token: MonkeyExci18nConfigService }, { token: MonkeyExcLogsConfigService }, { token: i1.MonkeyStyleGuideSettingsService }, { token: MonkeyExcServiceWorkerConfigService }, { token: MonkeyExcSecurityConsoleConfigService }, { token: MonkeyExcMaintenanceConfigService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcConfigService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcConfigService, providedIn: 'root' });
__decorate([
    MonkeyExcCoreService({
        httpResponse: {
            httpCodeIgnore: [404]
        },
        requestInProgress: {
            showProgress: false
        }
    })
], MonkeyExcConfigService.prototype, "init", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcConfigService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: MonkeyExcService }, { type: MonkeyExci18nConfigService }, { type: MonkeyExcLogsConfigService }, { type: i1.MonkeyStyleGuideSettingsService }, { type: MonkeyExcServiceWorkerConfigService }, { type: MonkeyExcSecurityConsoleConfigService }, { type: MonkeyExcMaintenanceConfigService }]; }, propDecorators: { init: [] } });

class MonkeyExcTokenStorageService {
    constructor(monkeyecxConfigService) {
        this.monkeyecxConfigService = monkeyecxConfigService;
        this.config = null;
        this.token = {
            username: '',
            program: '',
            accessToken: '',
            refreshToken: '',
            companyId: '',
            governmentId: '',
            companyTypeUrl: '',
            companyType: '',
            programAdmin: false,
            programType: '',
            role: '',
            _clearIgnore: {
                ignore: ['username', 'program']
            }
        };
        this.token$ = new BehaviorSubject(null);
        this.me$ = new BehaviorSubject(null);
        this.monkeyecxConfigService.config().subscribe((_) => {
            this.config = _;
        });
    }
    setAllTokens(token) {
        const { token$ } = this;
        Object.entries(token).forEach(([key, value]) => {
            if (MonkeyExcUtils.persistNullEmptyUndefined(value)) {
                localStorage.setItem(key, value);
            }
        });
        token$.next(token);
    }
    getAllTokens() {
        const { token } = this;
        const handledToken = Object.assign({}, token);
        Object.entries(token).forEach(([key, value]) => {
            handledToken[key] = localStorage.getItem(key);
        });
        return handledToken;
    }
    setAllMe(me) {
        const { me$ } = this;
        let previousMe = JSON.parse(localStorage.getItem('me'));
        Object.entries(me).forEach(([key, value]) => {
            if (MonkeyExcUtils.persistNullEmptyUndefined(value)) {
                previousMe = Object.assign(Object.assign({}, previousMe), { [key]: value });
            }
        });
        localStorage.setItem('me', JSON.stringify(previousMe));
        me$.next(previousMe);
    }
    getAllMe() {
        const me = localStorage.getItem('me');
        return JSON.parse(me);
    }
    tokenHasChanged() {
        return this.token$.asObservable();
    }
    meHasChanged() {
        return this.me$.asObservable() || null;
    }
    getToken() {
        return this.getAllTokens();
    }
    getMe() {
        return this.getAllMe();
    }
    setToken(token) {
        this.setAllTokens(token);
    }
    setMe(me) {
        this.setAllMe(me);
    }
    clear(force) {
        const { token } = this;
        try {
            Object.entries(token).forEach(([key, value]) => {
                if (token._clearIgnore.ignore.filter((val) => {
                    return val === key;
                }).length <= 0 ||
                    force === true) {
                    localStorage.removeItem(key);
                }
            });
            localStorage.removeItem('me');
        }
        catch (error) {
            return of(false);
        }
        return of(true);
    }
    /**
     * @param fields (the name of fields you want to clear. ie: ['companyId', 'role', ...])
     */
    clearCredentials(fields = ['companyId', 'governmentId', 'companyType', 'programAdmin', 'role']) {
        fields === null || fields === void 0 ? void 0 : fields.forEach((key) => {
            localStorage.removeItem(key);
        });
    }
}
MonkeyExcTokenStorageService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcTokenStorageService, deps: [{ token: MonkeyExcConfigService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcTokenStorageService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcTokenStorageService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcTokenStorageService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: MonkeyExcConfigService }]; } });

class MonkeyExcSecurityDirective {
    constructor(elementRef, tokenStorageService, cdr) {
        this.elementRef = elementRef;
        this.tokenStorageService = tokenStorageService;
        this.cdr = cdr;
        this.byExclusion = false;
        // not to do
    }
    getRole() {
        const { tokenCredentials } = this;
        if (!tokenCredentials)
            return '';
        if ((tokenCredentials === null || tokenCredentials === void 0 ? void 0 : tokenCredentials.programAdmin) === 'true') {
            return 'PROGRAM_ADMIN';
        }
        return (tokenCredentials === null || tokenCredentials === void 0 ? void 0 : tokenCredentials.role) || '';
    }
    handleAccess() {
        const { roles, byExclusion } = this;
        let display = 'none';
        const found = roles === null || roles === void 0 ? void 0 : roles.indexOf(this.getRole());
        if (byExclusion) {
            display = 'block';
            if (found > -1) {
                display = 'none';
            }
        }
        else {
            display = 'none';
            if (found > -1) {
                display = 'block';
            }
        }
        if (!roles || roles.length === 0 || (this.getRole() === 'PROGRAM_ADMIN'))
            display = 'block';
        this.elementRef.nativeElement.style.display = display;
        this.cdr.detectChanges();
    }
    ngOnInit() {
        this.elementRef.nativeElement.style.display = 'none';
        this.cdr.detectChanges();
        this.tokenStorageService.tokenHasChanged().subscribe(() => {
            this.tokenCredentials = this.tokenStorageService.getToken();
            this.handleAccess();
        });
        this.tokenCredentials = this.tokenStorageService.getToken();
        this.handleAccess();
    }
}
MonkeyExcSecurityDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcSecurityDirective, deps: [{ token: i0.ElementRef }, { token: MonkeyExcTokenStorageService }, { token: i0.ChangeDetectorRef }], target: i0.ɵɵFactoryTarget.Directive });
MonkeyExcSecurityDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: MonkeyExcSecurityDirective, selector: "[monkeyexcSecurity]", inputs: { roles: ["securityRoles", "roles"], byExclusion: ["securityByExclusion", "byExclusion"] }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcSecurityDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[monkeyexcSecurity]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: MonkeyExcTokenStorageService }, { type: i0.ChangeDetectorRef }]; }, propDecorators: { roles: [{
                type: Input,
                args: ['securityRoles']
            }], byExclusion: [{
                type: Input,
                args: ['securityByExclusion']
            }] } });

class MonkeyExcTooltipDirective {
    constructor(el, renderer) {
        this.el = el;
        this.renderer = renderer;
        this.offset = 10;
        // not to do
    }
    onMouseEnter() {
        if (!this.tooltip) {
            this.show();
        }
    }
    onMouseLeave() {
        if (this.tooltip) {
            this.hide();
        }
    }
    clickout() {
        if (this.tooltip) {
            this.hide();
        }
    }
    show() {
        this.create();
        this.setPosition();
        this.renderer.addClass(this.tooltip, 'monkey-tooltip-show');
    }
    hide() {
        this.renderer.removeClass(this.tooltip, 'monkey-tooltip-show');
        this.renderer.removeChild(document.body, this.tooltip);
        this.tooltip = null;
    }
    create() {
        const tooltipElement = document.createElement('div');
        this.tooltip = this.renderer.createElement('span');
        if (this.tooltipTitle) {
            const tooltipTitleElement = document.createElement('span');
            tooltipTitleElement.innerText = `${this.tooltipTitle}`;
            tooltipTitleElement.className = 'monkey-tooltip-title';
            tooltipElement.appendChild(tooltipTitleElement);
        }
        if (this.tooltipText) {
            const tooltipTextElement = document.createElement('span');
            tooltipTextElement.innerText = `${this.tooltipText}`;
            tooltipTextElement.className = 'monkey-tooltip-description';
            tooltipElement.appendChild(tooltipTextElement);
        }
        this.renderer.appendChild(this.tooltip, tooltipElement);
        this.renderer.appendChild(document.body, this.tooltip);
        this.renderer.addClass(this.tooltip, 'monkey-tooltip');
        this.renderer.addClass(this.tooltip, `monkey-tooltip-${this.tooltipPosition}`);
        this.renderer.setStyle(this.tooltip, '-webkit-transition', `opacity ${this.tooltipDelay}ms`);
        this.renderer.setStyle(this.tooltip, '-moz-transition', `opacity ${this.tooltipDelay}ms`);
        this.renderer.setStyle(this.tooltip, '-o-transition', `opacity ${this.tooltipDelay}ms`);
        this.renderer.setStyle(this.tooltip, 'transition', `opacity ${this.tooltipDelay}ms`);
    }
    setPosition() {
        const hostPos = this.el.nativeElement.getBoundingClientRect();
        const tooltipPos = this.tooltip.getBoundingClientRect();
        const scrollPos = window.pageYOffset || document.documentElement.scrollTop || document.body.scrollTop || 0;
        let top;
        let left;
        if (this.tooltipPosition === 'top') {
            top = hostPos.top - tooltipPos.height - this.offset;
            left = hostPos.left + (hostPos.width - tooltipPos.width) / 2;
        }
        if (this.tooltipPosition === 'bottom') {
            top = hostPos.bottom + this.offset;
            left = hostPos.left + (hostPos.width - tooltipPos.width) / 2;
        }
        if (this.tooltipPosition === 'left') {
            top = hostPos.top + (hostPos.height - tooltipPos.height) / 2;
            left = hostPos.left - tooltipPos.width - this.offset;
        }
        if (this.tooltipPosition === 'right') {
            top = hostPos.top + (hostPos.height - tooltipPos.height) / 2;
            left = hostPos.right + this.offset;
        }
        this.renderer.setStyle(this.tooltip, 'top', `${top + scrollPos}px`);
        this.renderer.setStyle(this.tooltip, 'left', `${left}px`);
    }
}
MonkeyExcTooltipDirective.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcTooltipDirective, deps: [{ token: i0.ElementRef }, { token: i0.Renderer2 }], target: i0.ɵɵFactoryTarget.Directive });
MonkeyExcTooltipDirective.ɵdir = i0.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.0.5", type: MonkeyExcTooltipDirective, selector: "[monkeyexcTooltip]", inputs: { tooltipDelay: "tooltipDelay", tooltipPosition: "tooltipPosition", tooltipText: "tooltipText", tooltipTitle: "tooltipTitle" }, host: { listeners: { "mouseenter": "onMouseEnter()", "mouseleave": "onMouseLeave()", "click": "clickout()" } }, ngImport: i0 });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcTooltipDirective, decorators: [{
            type: Directive,
            args: [{
                    selector: '[monkeyexcTooltip]'
                }]
        }], ctorParameters: function () { return [{ type: i0.ElementRef }, { type: i0.Renderer2 }]; }, propDecorators: { tooltipDelay: [{
                type: Input
            }], tooltipPosition: [{
                type: Input
            }], tooltipText: [{
                type: Input
            }], tooltipTitle: [{
                type: Input
            }], onMouseEnter: [{
                type: HostListener,
                args: ['mouseenter']
            }], onMouseLeave: [{
                type: HostListener,
                args: ['mouseleave']
            }], clickout: [{
                type: HostListener,
                args: ['click']
            }] } });

class MonkeyExcDirectivesModule {
}
MonkeyExcDirectivesModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDirectivesModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MonkeyExcDirectivesModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDirectivesModule, declarations: [MonkeyExcDragDropDirective,
        MonkeyExcFormatCurrency,
        MonkeyExcFormatUpper,
        MonkeyExcOnlyAlphaNumericDirective,
        MonkeyExcOnlyNumbersDirective,
        MonkeyExcSecurityDirective,
        MonkeyExcTooltipDirective], exports: [MonkeyExcDragDropDirective,
        MonkeyExcFormatCurrency,
        MonkeyExcFormatUpper,
        MonkeyExcOnlyAlphaNumericDirective,
        MonkeyExcOnlyNumbersDirective,
        MonkeyExcSecurityDirective,
        MonkeyExcTooltipDirective] });
MonkeyExcDirectivesModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDirectivesModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDirectivesModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        MonkeyExcDragDropDirective,
                        MonkeyExcFormatCurrency,
                        MonkeyExcFormatUpper,
                        MonkeyExcOnlyAlphaNumericDirective,
                        MonkeyExcOnlyNumbersDirective,
                        MonkeyExcSecurityDirective,
                        MonkeyExcTooltipDirective
                    ],
                    exports: [
                        MonkeyExcDragDropDirective,
                        MonkeyExcFormatCurrency,
                        MonkeyExcFormatUpper,
                        MonkeyExcOnlyAlphaNumericDirective,
                        MonkeyExcOnlyNumbersDirective,
                        MonkeyExcSecurityDirective,
                        MonkeyExcTooltipDirective
                    ]
                }]
        }] });

/* eslint-disable no-console */
class MonkeyExcAuthenticationService {
    constructor() {
        this.hadAtLeastOneLogin = () => {
            console.error('hadAtLeastOneLogin needs to be declared!');
            return null;
        };
        this.redirectApp = () => {
            console.error('redirectApp needs to be declared!');
            return null;
        };
        this.redirectLoginWelcomeBack = () => {
            console.error('redirectLoginWelcomeBack needs to be declared!');
            return null;
        };
        this.isAuthorized = () => {
            console.error('isAuthorized needs to be declared!');
            return false;
        };
        this.getRequestWithHeaders = (request) => {
            console.error('getRequestWithHeaders needs to be declared!');
            return null;
        };
        this.getRequestWithHeadersOb = (request) => {
            console.error('getRequestWithHeadersOb needs to be declared!');
            return null;
        };
        this.refreshShouldHappen = (response) => {
            console.error('refreshShouldHappen needs to be declared!');
            return false;
        };
        this.refreshToken = () => {
            console.error('refreshToken needs to be declared!');
            return null;
        };
        // not to do
    }
    init(args) {
        this.hadAtLeastOneLogin = (args === null || args === void 0 ? void 0 : args.hadAtLeastOneLogin) || this.hadAtLeastOneLogin.bind(this);
        this.redirectApp = (args === null || args === void 0 ? void 0 : args.redirectApp) || this.redirectApp.bind(this);
        this.redirectLoginWelcomeBack = (args === null || args === void 0 ? void 0 : args.redirectLoginWelcomeBack) ||
            this.redirectLoginWelcomeBack.bind(this);
        this.isAuthorized = (args === null || args === void 0 ? void 0 : args.isAuthorized) || this.isAuthorized.bind(this);
        this.getRequestWithHeaders = (args === null || args === void 0 ? void 0 : args.getRequestWithHeaders) ||
            this.getRequestWithHeaders.bind(this);
        console.log('===');
        console.log(args === null || args === void 0 ? void 0 : args.getRequestWithHeadersOb);
        console.log('===');
        this.getRequestWithHeadersOb = args === null || args === void 0 ? void 0 : args.getRequestWithHeadersOb.bind(this);
        this.refreshShouldHappen = (args === null || args === void 0 ? void 0 : args.refreshShouldHappen) || this.refreshShouldHappen.bind(this);
        this.refreshToken = (args === null || args === void 0 ? void 0 : args.refreshToken) || this.refreshToken.bind(this);
    }
}
MonkeyExcAuthenticationService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcAuthenticationService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcAuthenticationService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcAuthenticationService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcAuthenticationService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class MonkeyExcAuthGuardLogin {
    constructor(monkeyecxAuthenticationService) {
        this.monkeyecxAuthenticationService = monkeyecxAuthenticationService;
        // not to do
    }
    canActivate() {
        if (this.monkeyecxAuthenticationService.isAuthorized()) {
            this.monkeyecxAuthenticationService.redirectApp();
            return false;
        }
        if (this.monkeyecxAuthenticationService.hadAtLeastOneLogin()) {
            this.monkeyecxAuthenticationService.redirectLoginWelcomeBack();
            return false;
        }
        return true;
    }
}
MonkeyExcAuthGuardLogin.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcAuthGuardLogin, deps: [{ token: MonkeyExcAuthenticationService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcAuthGuardLogin.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcAuthGuardLogin, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcAuthGuardLogin, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: MonkeyExcAuthenticationService }]; } });

class MonkeyExcAuthGuard {
    constructor(monkeyecxAuthenticationService) {
        this.monkeyecxAuthenticationService = monkeyecxAuthenticationService;
        // not to do
    }
    canActivate() {
        const { monkeyecxAuthenticationService } = this;
        if (monkeyecxAuthenticationService.isAuthorized()) {
            return true;
        }
        monkeyecxAuthenticationService.redirectLoginWelcomeBack();
        return false;
    }
}
MonkeyExcAuthGuard.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcAuthGuard, deps: [{ token: MonkeyExcAuthenticationService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcAuthGuard.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcAuthGuard, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcAuthGuard, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: MonkeyExcAuthenticationService }]; } });

class MonkeyExcHttpErrorHandlingService extends MonkeyExcCommonsService {
    constructor(monkeyexcService, tokenStorage, monkeyexcAuthenticationService, router, snackbarService, translateService) {
        super(monkeyexcService, tokenStorage);
        this.monkeyexcAuthenticationService = monkeyexcAuthenticationService;
        this.router = router;
        this.snackbarService = snackbarService;
        this.translateService = translateService;
        super.resolve(null, null);
        this.geti18n(this.translateService, 'SERVICES.WARNING');
    }
    isHttpCodeIgnoreMessage(tp, httpCode) {
        var _a, _b;
        if (!MonkeyExcUtils.persistNullEmptyUndefined(tp) && !(tp === null || tp === void 0 ? void 0 : tp.httpResponse)) {
            return false;
        }
        const found = ((_b = (_a = tp === null || tp === void 0 ? void 0 : tp.httpResponse) === null || _a === void 0 ? void 0 : _a.httpCodeIgnore) === null || _b === void 0 ? void 0 : _b.indexOf(httpCode)) > -1;
        return found;
    }
    isHttpCodeIgnoreRedirect(tp, httpCode) {
        var _a, _b;
        if (!MonkeyExcUtils.persistNullEmptyUndefined(tp) && !(tp === null || tp === void 0 ? void 0 : tp.httpResponse)) {
            return false;
        }
        const found = ((_b = (_a = tp === null || tp === void 0 ? void 0 : tp.httpResponse) === null || _a === void 0 ? void 0 : _a.httpCodeIgnoreRedirect) === null || _b === void 0 ? void 0 : _b.indexOf(httpCode)) > -1;
        return found;
    }
    getMessageType(status) {
        if (status === 409 || status === 400) {
            return 'warning';
        }
        return 'error';
    }
    showMessage(message, error, mkc) {
        var _a;
        const { snackbarService } = this;
        if (!this.isHttpCodeIgnoreMessage(mkc, error.status)) {
            snackbarService.show({
                title: (_a = this.__i18n) === null || _a === void 0 ? void 0 : _a.TITLE,
                message,
                type: this.getMessageType(error.status),
                duration: 4000,
                horizontalPosition: 'center',
                verticalPosition: 'top'
            });
        }
    }
    handleMessage(error, mkc) {
        var _a;
        // eslint-disable-next-line camelcase
        const { notifications, error_description, message } = error.error;
        let customMessage = '';
        if (message) {
            customMessage = message;
        }
        // eslint-disable-next-line camelcase
        if (error_description) {
            // eslint-disable-next-line camelcase
            customMessage = error_description;
        }
        if (notifications) {
            customMessage = notifications;
        }
        if (!customMessage) {
            if (error.error instanceof Blob) {
                const blob = new Blob([error.error], {
                    type: 'application/json'
                });
                const reader = new FileReader();
                reader.addEventListener('loadend', (e) => {
                    const text = e.target.result;
                    const jsonResp = JSON.parse(text);
                    customMessage = jsonResp.notifications;
                    this.showMessage(customMessage, error, mkc);
                });
                reader.readAsText(blob);
            }
            else {
                this.showMessage((_a = this.__i18n['ERROR-HANDLING']) === null || _a === void 0 ? void 0 : _a.ERROR, error, mkc);
            }
        }
        else {
            this.showMessage(customMessage, error, mkc);
        }
    }
    handleError(error, mkc) {
        const { router } = this;
        const { status } = error;
        const routes = {
            403: 'forbidden',
            500: 'service-problems',
            503: 'service-problems'
        };
        const found = routes[status];
        let timeout = 0;
        if (found && !this.isHttpCodeIgnoreRedirect(mkc, error.status)) {
            const route = `/app/pages/${found}`.toLowerCase();
            timeout = 800;
            router.navigate([route]);
        }
        setTimeout(() => {
            this.handleMessage(error, mkc);
        }, timeout);
    }
    handleErrorRefreshToken(error, mkc) {
        if (error.status === 401 || error.status === 400) {
            NgZone.call(this.monkeyexcAuthenticationService.redirectLoginWelcomeBack());
        }
        else if (!this.isHttpCodeIgnoreMessage(mkc, error.status)) {
            this.handleMessage(error, mkc);
        }
    }
}
MonkeyExcHttpErrorHandlingService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpErrorHandlingService, deps: [{ token: MonkeyExcService }, { token: MonkeyExcTokenStorageService }, { token: MonkeyExcAuthenticationService }, { token: i1$3.Router }, { token: i1.MonkeyStyleGuideSnackbarService }, { token: i1$1.TranslateService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcHttpErrorHandlingService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpErrorHandlingService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpErrorHandlingService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: MonkeyExcService }, { type: MonkeyExcTokenStorageService }, { type: MonkeyExcAuthenticationService }, { type: i1$3.Router }, { type: i1.MonkeyStyleGuideSnackbarService }, { type: i1$1.TranslateService }]; } });

class MonkeyExcOthersErrorsHandlingService {
    constructor(modalService) {
        this.modalService = modalService;
        // not to do
    }
    handleError(error) {
        const { modalService } = this;
        const { message } = error;
        if (new RegExp(/Loading chunk [\d]+ failed/).test(message)) {
            modalService.open(VersionChangedComponent, {
                color: 'theme',
                size: 'md'
            });
        }
    }
}
MonkeyExcOthersErrorsHandlingService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcOthersErrorsHandlingService, deps: [{ token: i1.MonkeyStyleGuideModalService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcOthersErrorsHandlingService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcOthersErrorsHandlingService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcOthersErrorsHandlingService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1.MonkeyStyleGuideModalService }]; } });

class MonkeyExcErrorHandlingService {
    constructor(injector) {
        this.injector = injector;
        // not to do
    }
    handleError(error, type) {
        const { injector } = this;
        const handlingService = injector.get(MonkeyExcHandlingService);
        const httpErrorHandlingService = injector.get(MonkeyExcHttpErrorHandlingService);
        const othersErrorsHandlingService = injector.get(MonkeyExcOthersErrorsHandlingService);
        if (error instanceof HttpErrorResponse) {
            const sCredentials = handlingService.getMonkeyExcServiceCredentials();
            if (MonkeyExcUtils.persistNullEmptyUndefined(type) && type === 'refresh_token') {
                httpErrorHandlingService.handleErrorRefreshToken(error, sCredentials);
            }
            else
                httpErrorHandlingService.handleError(error, sCredentials);
        }
        else {
            othersErrorsHandlingService.handleError(error);
        }
    }
}
MonkeyExcErrorHandlingService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcErrorHandlingService, deps: [{ token: i0.Injector }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcErrorHandlingService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcErrorHandlingService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcErrorHandlingService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return [{ type: i0.Injector }]; } });

class MonkeyExcErrorHandlingModule {
    static forRoot() {
        return {
            ngModule: MonkeyExcErrorHandlingModule,
            providers: [
                {
                    provide: ErrorHandler,
                    useClass: MonkeyExcErrorHandlingService
                }
            ]
        };
    }
}
MonkeyExcErrorHandlingModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcErrorHandlingModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MonkeyExcErrorHandlingModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcErrorHandlingModule, imports: [CommonModule] });
MonkeyExcErrorHandlingModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcErrorHandlingModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcErrorHandlingModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule]
                }]
        }] });

class MonkeyExcHttpConfigErrorInterceptor {
    constructor(monkeyecxAuthenticationService, monkeyecxErrorHandlingService) {
        this.monkeyecxAuthenticationService = monkeyecxAuthenticationService;
        this.monkeyecxErrorHandlingService = monkeyecxErrorHandlingService;
        // no to do
    }
    intercept(request, next) {
        return next.handle(request).pipe(map((event) => {
            return event;
        }), catchError((error) => {
            if (this.monkeyecxAuthenticationService.refreshShouldHappen(error)) {
                return this.monkeyecxAuthenticationService.refreshToken().pipe(take(1), map(() => {
                    return this.monkeyecxAuthenticationService.getRequestWithHeaders(request);
                }), mergeMap((resp) => {
                    return next.handle(resp).pipe(catchError((error) => {
                        this.monkeyecxErrorHandlingService.handleError(error, 'refresh_token');
                        return throwError(null);
                    }));
                }), catchError((error) => {
                    this.monkeyecxErrorHandlingService.handleError(error, 'refresh_token');
                    return throwError(null);
                }));
            }
            return throwError(error);
        }));
    }
}
MonkeyExcHttpConfigErrorInterceptor.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigErrorInterceptor, deps: [{ token: MonkeyExcAuthenticationService }, { token: MonkeyExcErrorHandlingService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcHttpConfigErrorInterceptor.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigErrorInterceptor });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigErrorInterceptor, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: MonkeyExcAuthenticationService }, { type: MonkeyExcErrorHandlingService }]; } });

class MonkeyExcHttpConfigHeaderInterceptor {
    constructor(monkeyecxAuthenticationService, monkeyecxErrorHandlingService) {
        this.monkeyecxAuthenticationService = monkeyecxAuthenticationService;
        this.monkeyecxErrorHandlingService = monkeyecxErrorHandlingService;
        // not to do
    }
    intercept(request, next) {
        console.log('request');
        console.log(this.monkeyecxAuthenticationService);
        return this.monkeyecxAuthenticationService.getRequestWithHeadersOb(request).pipe(take(1), map((event) => {
            return event;
        }), mergeMap((resp) => {
            request = request.clone({
                setHeaders: resp
            });
            return next.handle(request);
        }), catchError((error) => {
            this.monkeyecxErrorHandlingService.handleError(error);
            return throwError(error);
        }));
    }
}
MonkeyExcHttpConfigHeaderInterceptor.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigHeaderInterceptor, deps: [{ token: MonkeyExcAuthenticationService }, { token: MonkeyExcErrorHandlingService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcHttpConfigHeaderInterceptor.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigHeaderInterceptor });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigHeaderInterceptor, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: MonkeyExcAuthenticationService }, { type: MonkeyExcErrorHandlingService }]; } });

class MonkeyExcRequestQueueHandlingService {
    constructor() {
        this.queue = [];
        this.newQueue = new BehaviorSubject(false);
        this.queues$ = new BehaviorSubject([]);
    }
    addToQueue(q) {
        this.queue.push(q);
        this.queues$.next(this.queue);
        this.newQueue.next(true);
    }
    markQueueItemAsFinish(q, status, action) {
        const saved = [...this.queue];
        this.queue = [
            ...saved.map((val) => {
                const valSaved = Object.assign({}, val);
                if (val.status === MonkeyExcQueueEvents.OnGoing) {
                    if (valSaved.item.id === q.item.id) {
                        return Object.assign(Object.assign({}, valSaved), { status: status || MonkeyExcQueueEvents.Finished, action });
                    }
                }
                return valSaved;
            })
        ];
        this.queues$.next(this.queue);
    }
    updateQueue(q, progress) {
        const saved = [...this.queue];
        this.queue = [
            ...saved.map((val) => {
                const valSaved = Object.assign({}, val);
                const { total, loaded } = progress;
                const currentPecentage = Math.floor((loaded / total) * 100);
                const totalPercentage = 100;
                if (valSaved.item.id === q.item.id) {
                    return Object.assign(Object.assign({}, valSaved), { progress: {
                            loaded,
                            total,
                            currentPercentage: currentPecentage,
                            totalPercentage
                        } });
                }
                return valSaved;
            })
        ];
        this.queues$.next(this.queue);
    }
    deleteQueue(q) {
        const saved = [...this.queue];
        this.queue = [
            ...saved.map((val) => {
                const valSaved = Object.assign({}, val);
                if (valSaved.item.id === q.item.id) {
                    return null;
                }
                return valSaved;
            })
        ].filter((_) => {
            return _;
        });
        this.queues$.next(this.queue);
    }
    setQueue(q) {
        this.addToQueue(q);
    }
    getQueue() {
        return this.queues$.asObservable();
    }
    finishQueueItem(q, action, status) {
        this.markQueueItemAsFinish(q, status, action);
    }
    removeQueueItem(q) {
        this.deleteQueue(q);
    }
    updateQueueItem(q, progress) {
        this.updateQueue(q, progress);
    }
    hasNewQueue() {
        return this.newQueue.pipe(map((_) => {
            return _;
        }));
    }
}
MonkeyExcRequestQueueHandlingService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestQueueHandlingService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcRequestQueueHandlingService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestQueueHandlingService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestQueueHandlingService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class MonkeyExcRequestQueueModalHandlingService {
    constructor() {
        this.queue = [];
        this.newQueue$ = new BehaviorSubject(false);
        this.allQueueFinished$ = new BehaviorSubject(false);
        this.queues$ = new BehaviorSubject([]);
    }
    addToQueue(q) {
        this.queue.push(q);
        this.queues$.next(this.queue);
        this.newQueue$.next(true);
    }
    markQueueItemAsFinish(q, status, action) {
        const saved = [...this.queue];
        this.queue = [
            ...saved.map((val) => {
                const valSaved = Object.assign({}, val);
                if (val.status === MonkeyExcQueueEvents.OnGoing) {
                    if (valSaved.item.id === q.item.id) {
                        return Object.assign(Object.assign({}, valSaved), { status: status || MonkeyExcQueueEvents.Finished, action });
                    }
                }
                return valSaved;
            })
        ];
        this.queues$.next(this.queue);
    }
    updateQueue(q, progress) {
        const saved = [...this.queue];
        this.queue = [
            ...saved.map((val) => {
                const valSaved = Object.assign({}, val);
                const { total, loaded } = progress;
                const currentPecentage = Math.floor((loaded / total) * 100);
                const totalPercentage = 100;
                if (valSaved.item.id === q.item.id) {
                    return Object.assign(Object.assign({}, valSaved), { progress: {
                            loaded,
                            total,
                            currentPercentage: currentPecentage,
                            totalPercentage
                        } });
                }
                return valSaved;
            })
        ];
        this.queues$.next(this.queue);
    }
    deleteQueue(q) {
        const saved = [...this.queue];
        this.queue = [
            ...saved.map((val) => {
                const valSaved = Object.assign({}, val);
                if (valSaved.item.id === q.item.id) {
                    return null;
                }
                return valSaved;
            })
        ].filter((_) => {
            return _;
        });
        this.queues$.next(this.queue);
        if (this.queue.length <= 0) {
            this.allQueueFinished$.next(true);
        }
    }
    setQueue(q) {
        this.addToQueue(q);
    }
    getQueue() {
        return this.queues$.asObservable();
    }
    finishQueueItem(q, action, status) {
        this.markQueueItemAsFinish(q, status, action);
    }
    removeQueueItem(q) {
        this.deleteQueue(q);
    }
    updateQueueItem(q, progress) {
        this.updateQueue(q, progress);
    }
    hasNewQueue() {
        return this.newQueue$.pipe(map((_) => {
            return _;
        }));
    }
    hasAllQueueFinished() {
        return this.allQueueFinished$.pipe(map((_) => {
            return _;
        }));
    }
}
MonkeyExcRequestQueueModalHandlingService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestQueueModalHandlingService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcRequestQueueModalHandlingService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestQueueModalHandlingService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestQueueModalHandlingService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

/* eslint-disable max-len */
class MonkeyExcHttpConfigQueueInterceptor {
    constructor(injector, monkeyecxRequestQueueHandlingService) {
        this.injector = injector;
        this.monkeyecxRequestQueueHandlingService = monkeyecxRequestQueueHandlingService;
        // not to do
    }
    intercept(request, next) {
        const { injector, isQueueProperty } = this;
        const monkeyecxHandlingService = injector.get(MonkeyExcHandlingService);
        const monkeyecxRequestQueue = monkeyecxHandlingService.getMonkeyExcRequestQueue();
        if (isQueueProperty(monkeyecxRequestQueue)) {
            this.monkeyecxRequestQueueHandlingService.setQueue(monkeyecxRequestQueue);
        }
        return next.handle(request).pipe(finalize(() => {
            if (isQueueProperty(monkeyecxRequestQueue)) {
                this.monkeyecxRequestQueueHandlingService.finishQueueItem(monkeyecxRequestQueue);
            }
        }));
    }
    isQueueProperty(mrq) {
        return (MonkeyExcUtils.persistNullEmptyUndefined(mrq) &&
            MonkeyExcUtils.persistNullEmptyUndefined(mrq.item.name));
    }
}
MonkeyExcHttpConfigQueueInterceptor.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigQueueInterceptor, deps: [{ token: i0.Injector }, { token: MonkeyExcRequestQueueHandlingService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcHttpConfigQueueInterceptor.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigQueueInterceptor });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigQueueInterceptor, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i0.Injector }, { type: MonkeyExcRequestQueueHandlingService }]; } });

/* eslint-disable max-len */
class MonkeyExcHttpConfigLoadingInProgressInterceptor {
    constructor(injector) {
        this.injector = injector;
        // no to do
    }
    intercept(request, next) {
        const { injector, isLoadingInProgressProperty } = this;
        const handlingService = injector.get(MonkeyExcHandlingService);
        const progressBarService = injector.get(MonkeyExcProgressBarService);
        const inProgress = handlingService.getMonkeyExcServiceCredentials()
            ? handlingService.getMonkeyExcServiceCredentials().requestInProgress
            : null;
        if (isLoadingInProgressProperty(inProgress)) {
            progressBarService.show();
        }
        return next.handle(request).pipe(finalize(() => {
            if (isLoadingInProgressProperty(inProgress)) {
                progressBarService.hide();
            }
        }));
    }
    isLoadingInProgressProperty(mlp) {
        return MonkeyExcUtils.persistNullEmptyUndefined(mlp) &&
            MonkeyExcUtils.persistNullEmptyUndefined(mlp.showProgress)
            ? mlp.showProgress
            : true;
    }
}
MonkeyExcHttpConfigLoadingInProgressInterceptor.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigLoadingInProgressInterceptor, deps: [{ token: i0.Injector }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcHttpConfigLoadingInProgressInterceptor.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigLoadingInProgressInterceptor });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigLoadingInProgressInterceptor, decorators: [{
            type: Injectable
        }], ctorParameters: function () { return [{ type: i0.Injector }]; } });

class MonkeyExcHttpConfigInterceptorModule {
    static forRoot() {
        return {
            ngModule: MonkeyExcHttpConfigInterceptorModule,
            providers: [
                {
                    provide: HTTP_INTERCEPTORS,
                    useClass: MonkeyExcHttpConfigHeaderInterceptor,
                    multi: true
                },
                {
                    provide: HTTP_INTERCEPTORS,
                    useClass: MonkeyExcHttpConfigErrorInterceptor,
                    multi: true
                },
                {
                    provide: HTTP_INTERCEPTORS,
                    useClass: MonkeyExcHttpConfigQueueInterceptor,
                    multi: true
                },
                {
                    provide: HTTP_INTERCEPTORS,
                    useClass: MonkeyExcHttpConfigLoadingInProgressInterceptor,
                    multi: true
                }
            ]
        };
    }
}
MonkeyExcHttpConfigInterceptorModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigInterceptorModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MonkeyExcHttpConfigInterceptorModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigInterceptorModule, imports: [CommonModule] });
MonkeyExcHttpConfigInterceptorModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigInterceptorModule, imports: [[CommonModule]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcHttpConfigInterceptorModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [CommonModule]
                }]
        }] });

class MonkeyExcModel {
    getAction(type) {
        const { _links } = this;
        if (!_links)
            return null;
        const link = _links[type.toLowerCase()];
        return link;
    }
}

/* eslint-disable indent */
class MonkeyExcConfigModule {
    constructor(parentModule) {
        if (parentModule) {
            throw new Error('MonkeyExcConfigModule is already loaded. Import it in the AppModule only!');
        }
    }
    static forRoot() {
        return {
            ngModule: MonkeyExcConfigModule,
            providers: [MonkeyExcConfigService]
        };
    }
}
MonkeyExcConfigModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcConfigModule, deps: [{ token: MonkeyExcConfigModule, optional: true, skipSelf: true }], target: i0.ɵɵFactoryTarget.NgModule });
MonkeyExcConfigModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcConfigModule });
MonkeyExcConfigModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcConfigModule });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcConfigModule, decorators: [{
            type: NgModule
        }], ctorParameters: function () { return [{ type: MonkeyExcConfigModule, decorators: [{
                    type: Optional
                }, {
                    type: SkipSelf
                }] }]; } });

class MonkeyExcFeatureToggleService {
    constructor(monkeyConfigService) {
        this.monkeyConfigService = monkeyConfigService;
        this.flagSubject$ = new BehaviorSubject(null);
        //not to do
    }
    getAllFlags() {
        this.flags = this.ldClient.allFlags();
        this.flagSubject$.next(true);
    }
    identify(config, environment) {
        var _a;
        if (config) {
            const email = 'monkey@monkey.exchange';
            const user = {
                email,
                key: `${(_a = config.program) === null || _a === void 0 ? void 0 : _a.token}#${email}`,
            };
            if (!this.ldClient) {
                this.ldClient = initialize(environment.launchDarklyClientSideID, user);
                this.ldClient.on('change', this.getAllFlags.bind(this));
                this.ldClient.on('ready', this.getAllFlags.bind(this));
            }
            else {
                this.ldClient.identify(user, null, this.getAllFlags);
            }
        }
    }
    apply(configBoostrap, environment) {
        if (environment.launchDarklyClientSideID) {
            this.monkeyConfigService.config().subscribe((config) => {
                this.identify(config, environment);
            });
        }
        else {
            this.flagSubject$.next(true);
        }
    }
    get onFlags() {
        return this.flagSubject$.asObservable();
    }
    getFlag(flag) {
        var _a;
        const flagValue = (_a = this.flags) === null || _a === void 0 ? void 0 : _a[flag];
        return MonkeyUtils.persistNullEmptyUndefined(flagValue) ? flagValue : null;
    }
}
MonkeyExcFeatureToggleService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFeatureToggleService, deps: [{ token: MonkeyExcConfigService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcFeatureToggleService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFeatureToggleService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcFeatureToggleService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return [{ type: MonkeyExcConfigService }]; } });

class MonkeyExcLoggedHandlingService {
    constructor() {
        this.schedules = [];
        // not to do
    }
    destroySchedule() {
        this.schedules.forEach((sch) => {
            clearInterval(sch.interval);
        });
        this.schedules = [];
    }
    addSchedule(sch) {
        this.schedules = sch;
    }
    destroy() {
        this.destroySchedule();
    }
}
MonkeyExcLoggedHandlingService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcLoggedHandlingService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcLoggedHandlingService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcLoggedHandlingService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcLoggedHandlingService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class MonkeyExcRequestDownloadHandlingService {
    constructor() {
        this.download = [];
        this.download$ = new BehaviorSubject([]);
    }
    addTo(q) {
        this.download.push(q);
        this.download$.next(this.download);
    }
    markItemAsFinish(q, status) {
        const saved = [...this.download];
        this.download = [
            ...saved
                .map((val) => {
                if (val.status === MonkeyExcDownloadEvents.OnGoing) {
                    const valSaved = Object.assign({}, val);
                    if (valSaved.item.id === q.item.id) {
                        return Object.assign(Object.assign({}, valSaved), { status: status || MonkeyExcDownloadEvents.Finished });
                    }
                    return valSaved;
                }
                return null;
            })
                .filter((_) => {
                return _;
            }),
        ];
        this.download = this.download.filter((_) => {
            return _.status === MonkeyExcDownloadEvents.OnGoing;
        });
        this.download$.next(this.download);
    }
    updateItem(q, loaded, total) {
        const saved = [...this.download];
        this.download = [
            ...saved.map((val) => {
                const valSaved = Object.assign({}, val);
                const currentPecentage = Math.floor((loaded / total) * 100);
                const totalPercentage = 100;
                if (valSaved.item.id === q.item.id) {
                    return Object.assign(Object.assign({}, valSaved), { loaded,
                        total, currentPercentage: currentPecentage, totalPercentage });
                }
                return valSaved;
            }),
        ];
        this.download$.next(this.download);
    }
    set(q) {
        this.addTo(q);
    }
    get() {
        return this.download$.asObservable();
    }
    update(q, loaded, total) {
        this.updateItem(q, loaded, total);
    }
    finishItem(q, status) {
        this.markItemAsFinish(q, status);
    }
    hasDownloadOnGoing() {
        const found = this.download.find((_) => {
            return _.status === MonkeyExcDownloadEvents.OnGoing;
        });
        return MonkeyExcUtils.persistNullEmptyUndefined(found);
    }
}
MonkeyExcRequestDownloadHandlingService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestDownloadHandlingService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcRequestDownloadHandlingService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestDownloadHandlingService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestDownloadHandlingService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], ctorParameters: function () { return []; } });

class MonkeyExcRequestDownloadedHandlingService {
    constructor() {
        this.downloaded = [];
        this.downloaded$ = new BehaviorSubject([]);
    }
    addTo(q) {
        this.downloaded.push(q);
        this.downloaded$.next(this.downloaded);
    }
    markItemAsFinish(q, status) {
        const saved = [...this.downloaded];
        this.downloaded = [
            ...saved.map((val) => {
                if (val.status === MonkeyExcDownloadEvents.OnGoing) {
                    const valSaved = Object.assign({}, val);
                    if (valSaved.item.id === q.item.id) {
                        return Object.assign(Object.assign({}, valSaved), { status: status || MonkeyExcDownloadEvents.Finished, action: q.action });
                    }
                    return valSaved;
                }
                return val;
            })
        ];
        this.downloaded$.next(this.downloaded);
    }
    set(q) {
        this.addTo(q);
    }
    get() {
        return this.downloaded$.asObservable();
    }
    finishItem(q, status) {
        this.markItemAsFinish(q, status);
    }
    hasDownloadOnGoing() {
        const found = this.downloaded.find((_) => {
            return _.status === MonkeyExcDownloadEvents.OnGoing;
        });
        return MonkeyExcUtils.persistNullEmptyUndefined(found);
    }
}
MonkeyExcRequestDownloadedHandlingService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestDownloadedHandlingService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcRequestDownloadedHandlingService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestDownloadedHandlingService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestDownloadedHandlingService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class MonkeyExcDiscoveryParamsService {
    constructor(router) {
        this.router = router;
        // not to do
    }
    getLastChild(route) {
        if (route.firstChild) {
            return this.getLastChild(route.firstChild);
        }
        return route;
    }
    setData(field, value) {
        const { root } = this.router.routerState.snapshot;
        const route = this.getLastChild(root);
        route.data[field] = value;
    }
    getData(field) {
        const { root } = this.router.routerState.snapshot;
        const route = this.getLastChild(root);
        const found = MonkeyExcUtils.persistNullEmptyUndefined(route) ? route.data[field] : null;
        return found;
    }
    getDataFromCurrentNavigation(field) {
        const navigation = this.router.getCurrentNavigation();
        let state = null;
        if (MonkeyExcUtils.persistNullEmptyUndefined(navigation)) {
            state = navigation.extras.state;
        }
        return state ? state[field] : null;
    }
    getParam(param) {
        const { root } = this.router.routerState.snapshot;
        const route = this.getLastChild(root);
        let found = MonkeyExcUtils.persistNullEmptyUndefined(route)
            ? route.paramMap.get(param)
            : '';
        if (!MonkeyExcUtils.persistNullEmptyUndefined(found))
            found = this.getData(param);
        return found;
    }
}
MonkeyExcDiscoveryParamsService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDiscoveryParamsService, deps: [{ token: i1$3.Router }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcDiscoveryParamsService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDiscoveryParamsService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcDiscoveryParamsService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: i1$3.Router }]; } });

class MonkeyExcRequestScheduleService {
    constructor(monkeyexcService, monkeyexcLoggedHandlingService) {
        this.monkeyexcService = monkeyexcService;
        this.monkeyexcLoggedHandlingService = monkeyexcLoggedHandlingService;
        this.schedule = [];
        // not to do
    }
    addToSchedule(q) {
        this.schedule.push(q);
        this.monkeyexcLoggedHandlingService.addSchedule(this.schedule);
    }
    removeFromSchedule(q) {
        clearInterval(q.interval);
        const saved = [...this.schedule];
        this.schedule = [
            ...saved.map((sch) => {
                const savedLocal = Object.assign({}, sch);
                if (sch.id === q.id) {
                    return null;
                }
                return savedLocal;
            })
        ].filter((_) => {
            return _;
        });
        this.monkeyexcLoggedHandlingService.addSchedule(this.schedule);
    }
    removeFromScheduleById(id) {
        const q = this.getScheduleById(id);
        clearInterval(q.interval);
        const saved = [...this.schedule];
        this.schedule = [
            ...saved.map((sch) => {
                const savedLocal = Object.assign({}, sch);
                if (sch.id === q.id) {
                    return null;
                }
                return savedLocal;
            })
        ].filter((_) => {
            return _;
        });
        this.monkeyexcLoggedHandlingService.addSchedule(this.schedule);
    }
    doCall(sch) {
        const { url, method, params, data, action } = sch;
        this.monkeyexcService[method.toLowerCase()](`${url}`, params).subscribe((resp) => {
            action(Object.assign(Object.assign({}, data), resp), sch);
        }, () => {
            this.removeFromSchedule(sch);
        });
    }
    setSchedule(q, delay = 3000) {
        const interval = setInterval(() => {
            this.doCall(Object.assign(Object.assign({}, q), { interval }));
        }, delay);
        const sch = Object.assign(Object.assign({}, q), { id: `${MonkeyExcUtils.getRandomString(40)}`, interval });
        this.addToSchedule(sch);
        return sch;
    }
    removeSchedule(q) {
        this.removeFromSchedule(q);
    }
    removeScheduleById(id) {
        this.removeFromScheduleById(id);
    }
    getScheduleById(id) {
        const q = this.schedule.find((sch) => {
            return sch.id === id;
        });
        return q;
    }
}
MonkeyExcRequestScheduleService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestScheduleService, deps: [{ token: MonkeyExcService }, { token: MonkeyExcLoggedHandlingService }], target: i0.ɵɵFactoryTarget.Injectable });
MonkeyExcRequestScheduleService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestScheduleService, providedIn: 'root' });
__decorate([
    MonkeyExcCoreService({
        httpResponse: {
            httpCodeIgnore: [400, 403, 404, 500, 503]
        },
        requestInProgress: {
            showProgress: false
        }
    })
], MonkeyExcRequestScheduleService.prototype, "doCall", null);
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyExcRequestScheduleService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return [{ type: MonkeyExcService }, { type: MonkeyExcLoggedHandlingService }]; }, propDecorators: { doCall: [] } });

/* eslint-disable no-unused-vars */
var OpSearch;
(function (OpSearch) {
    OpSearch["LIKE"] = ":*:value*";
    OpSearch["BETWEEN"] = ":first AND :last";
    OpSearch["OR"] = "OR";
    OpSearch["AND"] = "AND";
    OpSearch["GT"] = ">:value";
    OpSearch["LT"] = "<:value";
    OpSearch["EQUAL"] = "::value";
})(OpSearch || (OpSearch = {}));
class MonkeyExcSpecificationSearch {
    constructor() {
        // not to do
    }
    handleValue(value) {
        return Object.entries(value).map(([key, value1]) => {
            if (!MonkeyExcUtils.persistNullEmptyUndefined(value1)) {
                return null;
            }
            if (Array.isArray(value1)) {
                if (key === OpSearch.BETWEEN) {
                    return `${key}`.replace(':first', value1[0]).replace(':last', value1[1]);
                }
            }
            return `${key}`.replace(':value', value1.toString());
        })[0];
    }
    queryVisitor(value) {
        const okay = Object.entries(value).map(([key1, value1]) => {
            if (key1 === OpSearch.OR || key1 === OpSearch.AND) {
                const join = value1
                    .map((_) => {
                    return Object.entries(_).map(([key2, value2]) => {
                        if (value2 instanceof Object) {
                            value2 = this.handleValue(value2);
                        }
                        return this.criteriaParser(key2, value2);
                    })[0];
                })
                    .filter((_) => {
                    return _;
                })
                    .join(` ${key1} `);
                return `${join ? `(${join})` : ''}`;
            }
            if (value1 instanceof Object) {
                value1 = this.handleValue(value1);
            }
            return this.criteriaParser(key1, value1);
        });
        return okay
            .filter((_) => {
            return _;
        })
            .join(' AND ');
    }
    criteriaParser(key, value) {
        if (!MonkeyExcUtils.persistNullEmptyUndefined(value)) {
            return '';
        }
        if (value instanceof Object) {
            return this.queryVisitor(value);
        }
        return `${key}${value}`;
    }
    build(spec) {
        try {
            return this.queryVisitor(spec);
        }
        catch (e) {
            throw new Error(`MonkeyExcSpecificationSearch Error ${e}`);
        }
    }
    buildMoreThanOne(field, op = OpSearch.EQUAL) {
        var _a, _b;
        try {
            if (!this[field])
                return [];
            const filters = (_b = (_a = this[field]) === null || _a === void 0 ? void 0 : _a.split(',')) === null || _b === void 0 ? void 0 : _b.map((filter) => {
                if (!filter)
                    return null;
                return {
                    [field]: {
                        [op]: `${filter}`
                    }
                };
            }).filter((val) => { return val; });
            return filters || [];
        }
        catch (e) {
            throw new Error(`MonkeyExcSpecificationSearch Error ${e}`);
        }
    }
}

class MonkeyFrontCoreModuleModule {
}
MonkeyFrontCoreModuleModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyFrontCoreModuleModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
MonkeyFrontCoreModuleModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyFrontCoreModuleModule, imports: [CommonModule,
        HttpClientModule, i1$1.TranslateModule, MonkeyExcConfigModule, MonkeyExcHttpConfigInterceptorModule, MonkeyExcErrorHandlingModule, MonkeyStyleGuideModule, i1$5.ServiceWorkerModule, ClosedToMaintenanceModule,
        VersionChangedModule] });
MonkeyFrontCoreModuleModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyFrontCoreModuleModule, providers: [
        MonkeyStyleGuideModalService,
        MonkeyStyleGuideSettingsService,
        MonkeyStyleGuideSnackbarService,
    ], imports: [[
            CommonModule,
            HttpClientModule,
            TranslateModule.forRoot(),
            MonkeyExcConfigModule.forRoot(),
            MonkeyExcHttpConfigInterceptorModule.forRoot(),
            MonkeyExcErrorHandlingModule.forRoot(),
            MonkeyStyleGuideModule,
            ServiceWorkerModule.register('ngsw-worker.js'),
            ClosedToMaintenanceModule,
            VersionChangedModule,
        ]] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.0.5", ngImport: i0, type: MonkeyFrontCoreModuleModule, decorators: [{
            type: NgModule,
            args: [{
                    imports: [
                        CommonModule,
                        HttpClientModule,
                        TranslateModule.forRoot(),
                        MonkeyExcConfigModule.forRoot(),
                        MonkeyExcHttpConfigInterceptorModule.forRoot(),
                        MonkeyExcErrorHandlingModule.forRoot(),
                        MonkeyStyleGuideModule,
                        ServiceWorkerModule.register('ngsw-worker.js'),
                        ClosedToMaintenanceModule,
                        VersionChangedModule,
                    ],
                    providers: [
                        MonkeyStyleGuideModalService,
                        MonkeyStyleGuideSettingsService,
                        MonkeyStyleGuideSnackbarService,
                    ],
                }]
        }] });

/*
 * Public API Surface of monkey-front-core
 */

/**
 * Generated bundle index. Do not edit.
 */

export { ClosedToMaintenanceComponent, ClosedToMaintenanceModule, decoratorsUtils as DecoratorsUtils, MonkeyExcAuthGuard, MonkeyExcAuthGuardLogin, MonkeyExcAuthenticationService, MonkeyExcCommonsService, MonkeyExcConfigModule, MonkeyExcConfigService, MonkeyExcCookieStorageService, MonkeyExcCoreClearDecorators, MonkeyExcCoreLog, MonkeyExcCoreService, MonkeyExcCoreServiceConstructor, MonkeyExcCoreServicePaged, MonkeyExcCoreServiceQueue, MonkeyExcDirectivesModule, MonkeyExcDiscoveryParamsService, MonkeyExcDisplayFirstNamePipe, MonkeyExcDocumentTypePipe, MonkeyExcDragDropDirective, MonkeyExcErrorHandlingModule, MonkeyExcErrorHandlingService, MonkeyExcFeatureToggleService, MonkeyExcFormatCurrency, MonkeyExcFormatCurrencyPipe, MonkeyExcFormatDateTimelapsePipe, MonkeyExcFormatDocumentPipe, MonkeyExcFormatNumber, MonkeyExcFormatSizePipe, MonkeyExcFormatUpper, MonkeyExcFormatValue, MonkeyExcFormatZipCodePipe, MonkeyExcHandlingService, MonkeyExcHttpConfigErrorInterceptor, MonkeyExcHttpConfigHeaderInterceptor, MonkeyExcHttpConfigInterceptorModule, MonkeyExcHttpConfigLoadingInProgressInterceptor, MonkeyExcHttpConfigQueueInterceptor, MonkeyExcHttpErrorHandlingService, MonkeyExcLoggedHandlingService, MonkeyExcLogsConfigService, MonkeyExcMaintenanceConfigService, MonkeyExcModel, MonkeyExcOnlyAlphaNumericDirective, MonkeyExcOnlyNumbersDirective, MonkeyExcOthersErrorsHandlingService, MonkeyExcPipesModule, MonkeyExcProgressBarComponent, MonkeyExcProgressBarModule, MonkeyExcProgressBarService, MonkeyExcRequestDownloadHandlingService, MonkeyExcRequestDownloadedHandlingService, MonkeyExcRequestPagedHandling, MonkeyExcRequestQueueHandlingService, MonkeyExcRequestQueueModalHandlingService, MonkeyExcRequestScheduleService, MonkeyExcSecurityConsoleConfigService, MonkeyExcSecurityDirective, MonkeyExcService, MonkeyExcServiceDownload, MonkeyExcServiceUpload, MonkeyExcServiceWorkerConfigService, MonkeyExcSpecificationSearch, MonkeyExcTextTruncatePipe, MonkeyExcTokenStorageService, MonkeyExcTooltipDirective, MonkeyExcTruncateQtdPipe, MonkeyExcUtils, MonkeyExci18nConfigService, MonkeyFrontCoreModuleModule, OpSearch, statics as Statics, validateUtils as ValidateUtils, VersionChangedComponent, VersionChangedModule };
//# sourceMappingURL=monkey-front-core.js.map
