export interface MonkeyExcConfigProgram {
    token: string;
    name: string;
    type: string;
    register: {
        seller: {
            types: string[];
            documentTypes: string[];
            legalNatures: string[];
        };
        sponsor: {
            types: string[];
        };
        buyer: {
            calculationTypes: string[];
            legalNatures: string[];
            types: string[];
        };
    };
    settings: {
        editSponsorTax: boolean;
    };
}
export interface MonkeyExcConfigTheme {
    logos: {
        favicon: string;
        toolbar: string;
        login: string;
        footer: string;
    };
}
export interface MonkeyExcConfigSupport {
    phones?: {
        attendant?: string;
        numbers?: string[];
    }[];
    emails?: {
        attendant?: string;
        recipients?: string[];
    }[];
    information?: {
        message?: string;
        action?: string;
    };
}
export interface MonkeyExcConfigi18n {
    lang?: string;
    currency?: string;
    'google-chart-language'?: string;
}
export interface MonkeyExcConfigLogs {
    enabled: boolean;
}
export interface MonkeyExcConfig {
    program?: MonkeyExcConfigProgram;
    theme?: MonkeyExcConfigTheme;
    support?: MonkeyExcConfigSupport;
    i18n?: MonkeyExcConfigi18n;
    logs?: MonkeyExcConfigLogs;
}
