import { ActivatedRouteSnapshot, Router, RouterStateSnapshot } from '@angular/router';
import { TranslateService } from '@ngx-translate/core';
import { BehaviorSubject } from 'rxjs';
import { MonkeyExcErrorResponse, MonkeyExcHandledErrorResponse, MonkeyExcRequestPaged, MonkeyExcRequestSchedule, MonkeyExcResponsePaged, MonkeyExcTokenCredentials, MonkeyExcTranslateOptions } from '../../interfaces';
import { MonkeyExcTokenStorageService } from '../storage';
import { MonkeyExcRequestScheduleService } from '../schedules';
import { MonkeyExcRequestQueueHandlingService } from '../request-queue';
import { MonkeyExcFeatureToggleService } from '../config/monkeyexc-feature-toggle.service';
import { MonkeyExcService } from '../monkeyexc-service.service';
export declare class MonkeyExcCommonsService {
    monkeyexcService?: MonkeyExcService;
    tokenStorage?: MonkeyExcTokenStorageService;
    otherArgs?: {
        router?: Router;
        schedule?: {
            service: MonkeyExcRequestScheduleService;
            options?: {
                clearOnChangeRoute?: boolean;
            };
        };
        queue?: {
            service: MonkeyExcRequestQueueHandlingService;
        };
    };
    private flagValidator;
    __data: any | any[];
    __params: any | any[];
    __error: MonkeyExcErrorResponse;
    __handledError: MonkeyExcHandledErrorResponse;
    __page: MonkeyExcResponsePaged;
    __search: any;
    __requestPaged: MonkeyExcRequestPaged;
    __onSearchChanged$: BehaviorSubject<any>;
    __onDataChanged$: BehaviorSubject<any>;
    __onLoadingInProgress$: BehaviorSubject<boolean>;
    __onDataDeleted$: BehaviorSubject<any>;
    __onErrorChanged$: BehaviorSubject<any>;
    __onGovernmentIdDataChanged$: BehaviorSubject<any>;
    __onZipCodeDataChanged$: BehaviorSubject<any>;
    __oni18nDataChanged$: BehaviorSubject<any>;
    __onDoSearch$: BehaviorSubject<MonkeyExcRequestPaged>;
    __onDoPagination$: BehaviorSubject<Function>;
    __tokenCredentials: MonkeyExcTokenCredentials;
    __schedule: MonkeyExcRequestSchedule;
    __i18n: any;
    constructor(monkeyexcService?: MonkeyExcService, tokenStorage?: MonkeyExcTokenStorageService, otherArgs?: {
        router?: Router;
        schedule?: {
            service: MonkeyExcRequestScheduleService;
            options?: {
                clearOnChangeRoute?: boolean;
            };
        };
        queue?: {
            service: MonkeyExcRequestQueueHandlingService;
        };
    });
    private handleInit;
    private getRole;
    private allowedSecurityAccess;
    private navigateToErrorPage;
    setPage(requestPaged: MonkeyExcRequestPaged): this;
    nextPage(): boolean;
    getEmbeddedData(data: any, field: string): any[] | any;
    getNormalizedUrl(url: string): string;
    clear(clearData: boolean): void;
    resolve(route: ActivatedRouteSnapshot, state: RouterStateSnapshot, otherArgs?: {
        callbackMain: Function;
        router?: Router;
        security?: {
            roles: string[];
            byExclusion?: boolean;
        };
        callbackPagination?: Function;
        translateOptions?: MonkeyExcTranslateOptions;
        feature?: {
            service: MonkeyExcFeatureToggleService;
            flag: string;
        };
    }): void;
    getHTTPHeaderApplicationPDF(): Object;
    genericMethod(link: any, data?: any, callback?: Function): void;
    geti18n(translateService: TranslateService, keys: string | string[]): void;
}
