import { Router } from '@angular/router';
import { HttpErrorResponse } from '@angular/common/http';
import { TranslateService } from '@ngx-translate/core';
import { MonkeyStyleGuideSnackbarService } from 'monkey-style-guide';
import { MonkeyExcAuthenticationService } from '../auth';
import { MonkeyExcService } from '../monkeyexc-service.service';
import { MonkeyExcTokenStorageService } from '../storage';
import { MonkeyExcCommonsService } from '../commons';
import { MonkeyExcServiceCredentials } from '../../interfaces';
import * as i0 from "@angular/core";
export declare class MonkeyExcHttpErrorHandlingService extends MonkeyExcCommonsService {
    private monkeyexcAuthenticationService;
    private router;
    private snackbarService;
    private translateService;
    constructor(monkeyexcService: MonkeyExcService, tokenStorage: MonkeyExcTokenStorageService, monkeyexcAuthenticationService: MonkeyExcAuthenticationService, router: Router, snackbarService: MonkeyStyleGuideSnackbarService, translateService: TranslateService);
    private isHttpCodeIgnoreMessage;
    private isHttpCodeIgnoreRedirect;
    private getMessageType;
    private showMessage;
    private handleMessage;
    handleError(error: HttpErrorResponse, mkc: MonkeyExcServiceCredentials): void;
    handleErrorRefreshToken(error: HttpErrorResponse, mkc: MonkeyExcServiceCredentials): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MonkeyExcHttpErrorHandlingService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MonkeyExcHttpErrorHandlingService>;
}
