import { Observable } from 'rxjs';
import { MonkeyExcConfigService } from '../config/monkeyexc-config.service';
import { MonkeyExcMeCredentials, MonkeyExcTokenCredentials } from '../../interfaces';
import * as i0 from "@angular/core";
export declare class MonkeyExcTokenStorageService {
    private monkeyecxConfigService;
    private token;
    private token$;
    private me$;
    private config;
    constructor(monkeyecxConfigService: MonkeyExcConfigService);
    private setAllTokens;
    private getAllTokens;
    private setAllMe;
    private getAllMe;
    tokenHasChanged(): Observable<MonkeyExcTokenCredentials>;
    meHasChanged(): Observable<MonkeyExcMeCredentials>;
    getToken(): MonkeyExcTokenCredentials;
    getMe(): MonkeyExcMeCredentials;
    setToken(token: MonkeyExcTokenCredentials): void;
    setMe(me: MonkeyExcMeCredentials): void;
    clear(force?: boolean): Observable<boolean>;
    /**
     * @param fields (the name of fields you want to clear. ie: ['companyId', 'role', ...])
     */
    clearCredentials(fields?: string[]): void;
    static ɵfac: i0.ɵɵFactoryDeclaration<MonkeyExcTokenStorageService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<MonkeyExcTokenStorageService>;
}
